'############################################################
Type TDynamicImageReduced1
'############################################################
	Field Stripe:TImage[], Width:Int, Height:Int, Count:Int, PixelStep:Int
	'-----------------------------------------------------------------------------------------------------------------
	Function build:TDynamicImageReduced1(TotalPixmap:TPixmap, PixelStep:Int = 4)
		Local NTDI:TDynamicImageReduced1 = New TDynamicImageReduced1
		Local StripePixmap:TPixmap
		NTDI.PixelStep = PixelStep
		NTDI.Width = PixmapWidth(TotalPixmap)
		NTDI.Height = PixmapHeight(TotalPixmap)
		NTDI.Count =  NTDI.Height / PixelStep
		NTDI.Stripe = New TImage[NTDI.Count+1]
		Local y:Int 'ARGB:Int, A:Int, R:Int, G:Int, B:Int
		While y + PixelStep - 1 < NTDI.Height
			StripePixmap = CreatePixmap(NTDI.Width, PixelStep, PF_BGRA8888)
			ClearPixels(StripePixmap, 0)
			For Local i:Int = 0 To NTDI.Width-1
				'---------------------------------------
				For Local j:Int = 0 To PixelStep - 1
					WritePixel(StripePixmap, i, j, ReadPixel(TotalPixmap, i, y + j) )
				Next
				'---------------------------------------
			Next
			'---------------------------------------
			NTDI.Stripe[ y / PixelStep ] = LoadImage(StripePixmap)
			SetImageHandle( NTDI.Stripe[ y / PixelStep ], 0, (PixelStep-1) / 2 )
			y = y + PixelStep
		Wend
		'------------------
		Return NTDI
	End Function
	'-----------------------------------------------------------------------------------------------------------------
	Method draw(Point:Float[], RGB1:Int[], RGB2:Int[])
		'----------------------------------------------------------------------------------------
		Local OtherScale:Float, Angle:Float[3], StepDistance:Float[3]
		Local Distance1:Float = Sqr( (Point[2]-Point[0])^2 + (Point[3]-Point[1])^2 )
		Local Distance2:Float = Sqr( (Point[6]-Point[4])^2 + (Point[7]-Point[5])^2 )
		Local ReducedCount:Int = Min(Count, Max(Distance1, Distance2) / PixelStep)
		Local CountStep:Float = 1.0 * Count / ReducedCount
		Angle[0] = ATan2(Point[3] - Point[1], Point[2] - Point[0])
		Angle[1] = ATan2(Point[5] - Point[7], Point[4] - Point[6])
		StepDistance[0] = 1.0 * Distance1 / ReducedCount 
		StepDistance[1] = 1.0 * Distance2 / ReducedCount
		OtherScale = Max(Distance1, Distance2) / ReducedCount / PixelStep
		'-----------------------------------------------------------------------------------
		Local x:Float[] = [Point[0], Point[6]]
		Local y:Float[] = [Point[1], Point[7]]
		Local xScale:Float = 1.0 * Sqr( (x[1]-x[0])^2 + (y[1]-y[0])^2 ) / Width
		Local i:Float = 0
		While i =< Count - 1
			Local Gradient:Float = 1.0 * i / (Count-1)
			Local GegenGradient:Float = 1 - Gradient
			SetColor RGB1[0] * GegenGradient + RGB2[0] * Gradient, RGB1[1] * GegenGradient + RGB2[1] * Gradient, RGB1[2] * GegenGradient + RGB2[2] * Gradient
			SetScale xScale, OtherScale
			DrawImage Stripe[i], x[0], y[0]
			x[0] = x[0] + StepDistance[0] * Cos(Angle[0])
			y[0] = y[0] + StepDistance[0] * Sin(Angle[0])
			x[1] = x[1] + StepDistance[1] * Cos(Angle[1])
			y[1] = y[1] + StepDistance[1] * Sin(Angle[1])
			xScale = 1.0 * Sqr( (x[1]-x[0])^2 + (y[1]-y[0])^2 ) / Width
			i = i + CountStep
		Wend
		'----------------------------------------------------------------------------------------
	End Method	
'############################################################
End Type 'TDynamicImageReduced1
'############################################################
Type TDynamicImageReduced2
'############################################################
	Field Stripe:TImage[], Width:Int, Height:Int, Count:Int, PixelStep:Int
	'-----------------------------------------------------------------------------------------------------------------
	Function build:TDynamicImageReduced2(TotalPixmap:TPixmap, PixelStep:Int = 4)
		Local NTDI:TDynamicImageReduced2 = New TDynamicImageReduced2
		Local StripePixmap:TPixmap
		NTDI.PixelStep = PixelStep
		NTDI.Width = PixmapWidth(TotalPixmap)
		NTDI.Height = PixmapHeight(TotalPixmap)
		NTDI.Count =  NTDI.Width / PixelStep
			NTDI.Stripe = New TImage[NTDI.Count+1]
			Local x:Int 'ARGB:Int, A:Int, R:Int, G:Int, B:Int
			While x + PixelStep - 1 < NTDI.Width
				StripePixmap = CreatePixmap(PixelStep, NTDI.Height, PF_BGRA8888)
				ClearPixels(StripePixmap, 0)
				For Local i:Int = 0 To NTDI.Height-1
					'---------------------------------------
					For Local j:Int = 0 To PixelStep - 1
						WritePixel(StripePixmap, j, i, ReadPixel(TotalPixmap, x + j, i) )
					Next
					'---------------------------------------
				Next
				'---------------------------------------
				NTDI.Stripe[ x / PixelStep ] = LoadImage(StripePixmap)
				SetImageHandle( NTDI.Stripe[ x / PixelStep ], (PixelStep-1) / 2, 0 )
				x = x + PixelStep
			Wend
		'------------------
		Return NTDI
	End Function
	'-----------------------------------------------------------------------------------------------------------------
	Method draw(Point:Float[], RGB1:Int[], RGB2:Int[])
		'----------------------------------------------------------------------------------------
		Local OtherScale:Float, Angle:Float[3], StepDistance:Float[3]
		Local Distance1:Float = Sqr( (Point[0]-Point[6])^2 + (Point[1]-Point[7])^2 )
		Local Distance2:Float = Sqr( (Point[4]-Point[2])^2 + (Point[5]-Point[3])^2 )
		Local ReducedCount:Int = Min(Count, Max(Distance1, Distance2) / PixelStep)
		Local CountStep:Float = 1.0 * Count / ReducedCount
		Angle[0] = ATan2(Point[7] - Point[1], Point[6] - Point[0])
		Angle[1] = ATan2(Point[5] - Point[3], Point[4] - Point[2])
		StepDistance[0] = 1.0 * Distance1 / ReducedCount
		StepDistance[1] = 1.0 * Distance2 / ReducedCount
		OtherScale = Max(Distance1, Distance2) / ReducedCount / PixelStep
		'-----------------------------------------------------------------------------------
		Local x:Float[] = [Point[0], Point[2]]
		Local y:Float[] = [Point[1], Point[3]]
		Local yScale:Float = 1.0 * Sqr( (x[1]-x[0])^2 + (y[1]-y[0])^2 ) / Height
		Local i:Float = 0
		While i =< Count - 1
			Local Gradient:Float = 1.0 * i / (Count-1)
			Local GegenGradient:Float = 1 - Gradient
			SetColor RGB1[0] * GegenGradient + RGB2[0] * Gradient, RGB1[1] * GegenGradient + RGB2[1] * Gradient, RGB1[2] * GegenGradient + RGB2[2] * Gradient
			SetScale OtherScale, yScale
			DrawImage Stripe[i], x[0], y[0]
			x[0] = x[0] + StepDistance[0] * Cos(Angle[0])
			y[0] = y[0] + StepDistance[0] * Sin(Angle[0])
			x[1] = x[1] + StepDistance[1] * Cos(Angle[1])
			y[1] = y[1] + StepDistance[1] * Sin(Angle[1])
			yScale = 1.0 * Sqr( (x[1]-x[0])^2 + (y[1]-y[0])^2 ) / Height
			i = i + CountStep
		Wend		
	End Method	
'############################################################
End Type 'TDynamicImageReduced2