'#################################
Type TElement
'#################################
	Global Channel:TChannel, InteractionChannel:TChannel, GlobalElementActiv:Byte
	Field PosX:Int, PosY:Int, HalfWidth:Int, HalfHeight:Int, Image:TImage, Text:String, Gif:TGif, SpeedControl:TSpeedControl[3], staystarttime:Int
	Field CoverMosaik:TImage, CoverSize:Int, CoverAnzahl:Int, Zeilen:Int, Spalten:Int, Verteilung:Int[]
	Field Style:Int, DelayTime:Int, AnimationTime:Int, ComeInSoundPath:String, StaySoundPath:String, RGB:Int[]
	Field Interaktion:Int, aktiviert:Byte, AktionsInfo:String, Aktionsbild:TImage, AktionsSound:TSound, Fontfile:String, FontSize:Int
	'===============================
	Function build:TElement(Info:String, AnimationStyle:Int = 0, DelayTime:Int = -1, AnimationTime:Int = 1000, NewGif:TGif = Null, ComeInSoundPath:String = "", StaySoundPath:String = "", Interaktion:Int = 0, AktionsInfo:String = "", RGB:Int[] = Null, FontFile:String = "", FontSize:Int = 28)
		Local NTE:TElement = New TElement
		If NewGif = Null Then
			If FileType(Info) <> 1 Then 'Textelement laden
				NTE.Fontfile = Fontfile
				NTE.Fontsize = Fontsize
				FontCollection.set(Fontfile, Fontsize)
				NTE.Text = Info
				NTE.HalfWidth = TextWidth(Info) / 2
				NTE.HalfHeight = TextHeight(Info) / 2
			Else   'If FileType(Info) = 1 Then
				NTE.Image = LoadImage(Info) 'Bildelement laden
				MidHandleImage(NTE.Image)
				NTE.HalfWidth = ImageWidth(NTE.Image) / 2
				NTE.HalfHeight = ImageHeight(NTE.Image) / 2
			End If
		Else 'TGif-Element bernehmen
			NTE.Gif = NewGif
			NTE.HalfWidth = 0.5*NTE.Gif.Width
			NTE.HalfHeight = 0.5*NTE.Gif.Height
		End If
		NTE.Style = AnimationStyle
		NTE.DelayTime = DelayTime
		NTE.AnimationTime = AnimationTime
		NTE.ComeInSoundPath = ComeInSoundPath
		NTE.StaySoundPath = StaySoundPath
		NTE.Interaktion = Interaktion
		NTE.AktionsInfo = AktionsInfo
		If NTE.Interaktion = 3 Then
			NTE.Aktionsbild = LoadImage(NTE.AktionsInfo)
		ElseIf NTE.Interaktion = 4 Then
			NTE.AktionsSound = LoadSound(NTE.AktionsInfo)
		End If
		If Len(RGB) < 3 Then
			NTE.RGB = [255,255,255]
		Else
			NTE.RGB = RGB
		End If
		NTE.CoverAnzahl = 64
		Return NTE	
	'===============================
	End Function
	'===============================
	Method draw(X:Float, Y:Float, XZoom:Float = 1.0, YZoom:Float = 1.0, Rotation:Float = 0.0, Alpha:Float = 1.0)
	'===============================
		SetColor RGB[0], RGB[1], RGB[2]
		SetAlpha Alpha
		If Image <> Null Then
			SetRotation Rotation
			SetScale XZoom, YZoom
			DrawImage Image, X, Y
		ElseIf Gif = Null Then
			FontCollection.set(Fontfile, Fontsize)
			SetHandle HalfWidth, HalfHeight
			SetRotation Rotation
			SetScale XZoom, YZoom
			DrawText Text, X, Y
		Else
			SetRotation Rotation
			SetScale XZoom, YZoom
			Gif.draw(X, Y)
		End If
	'===============================
	End Method   'draw()
	'===============================
	Method comeIn:Byte()
	'===============================
		If SpeedControl[0] <> Null Then
			SpeedControl[0].UpdateTime()
			SpeedControl[0].UpdateStates(AnimationTime)
			If SpeedControl[0].Duration >= AnimationTime Then
				SetColor RGB[0], RGB[1], RGB[2]
				If Image <> Null Then
					DrawImage Image, PosX, PosY
				ElseIf Gif = Null Then
					FontCollection.set(Fontfile, Fontsize)
					SetHandle HalfWidth, HalfHeight
					DrawText Text, PosX, PosY
				Else
					Gif.draw(PosX, PosY)
				End If
				Return True
			End If
			'-------------------------------------------------------------------
			Select Style
				'-------------------------------------------------------------------
				Case 0 'NUR Alpha-Blend
					Local Value:Float = SpeedControl[0].GetValue(0,14)
					draw(PosX, PosY,,,, Value)
					SetAlpha 1.0
				'-------------------------------------------------------------------
				Case 1 'Komplett Zoomen
					Local Value:Float = SpeedControl[0].GetValue(0,7)
					draw(PosX, PosY, Value, Value,, Value)
					SetScale 1.0, 1.0
					SetAlpha 1.0
				Case 2 'Horizontal Zoomen
					Local Value:Float = SpeedControl[0].GetValue(0,7)
					draw(PosX, PosY, Value,,, Value)
					SetScale 1.0, 1.0
					SetAlpha 1.0					
				Case 3 'Horizontal "Aufziehen" von Links nach Rechts
					Local Value:Float = SpeedControl[0].GetValue(0,13)
					draw(PosX-HalfWidth + Value*HalfWidth, PosY, Value,,, Value)
					SetScale 1.0, 1.0
					SetAlpha 1.0
				'-------------------------------------------------------------------
				Case 4 'Einfaches Hereinfliegen von Links nach Rechts
					Local Value:Float = SpeedControl[0].GetValue(0,1) 'oder (0,2)
					draw(Value*PosX, PosY,,,, Value)
					SetAlpha 1.0
				Case 5 'Einfaches Hereinfliegen von Rechts nach Links
					Local Value:Float = SpeedControl[0].GetValue(0,1) 'oder (0,2)
					draw(PosX + (1-Value)*ScreenWidth, PosY,,,, Value)
					SetAlpha 1.0
				Case 6 'Einfaches Hereinfliegen von Unten nach Oben
					Local Value:Float = SpeedControl[0].GetValue(0,1) 'oder (0,2)
					draw(PosX, PosY+(1-Value)*ScreenHeight,,,, Value)
					SetAlpha 1.0
				Case 7 'Einfaches Hereinfliegen von Oben nach Unten
					Local Value:Float = SpeedControl[0].GetValue(0,1) 'oder (0,2)
					draw(PosX, Value*PosY,,,, Value)
					SetAlpha 1.0
				'-------------------------------------------------------------------
				Case 8 'CoverJalousine von Links nach Rechts
					Local Value:Float = SpeedControl[0].GetValue(0,0)
					draw(PosX, PosY,,,, 0.75+0.25*Value)
					SetColor 255,255,255
					SetAlpha 1.0
					For Local i:Int = 0 To (1-Value)*(Spalten-1)
						DrawImage CoverMosaik, PosX-HalfWidth + (Spalten-1-i)*CoverSize, PosY-HalfHeight, (Spalten-1-i)
					Next
				Case 9 'CoverJalousine von Rechts nach Links
					Local Value:Float = SpeedControl[0].GetValue(0,0)
					draw(PosX, PosY,,,, 0.75+0.25*Value)
					SetColor 255,255,255
					SetAlpha 1.0
					For Local i:Int = 0 To (1-Value)*(Spalten-1)
						DrawImage CoverMosaik, PosX-HalfWidth + i*CoverSize, PosY-HalfHeight, i
					Next
				Case 10 'CoverJalousine von Oben nach Unten
					Local Value:Float = SpeedControl[0].GetValue(0,0)
					draw(PosX, PosY,,,, 0.75+0.25*Value)
					SetColor 255,255,255
					SetAlpha 1.0
					For Local i:Int = 0 To (1-Value)*(Zeilen-1)
						DrawImage CoverMosaik, PosX-HalfWidth, PosY-HalfHeight + (Zeilen-1-i)*CoverSize, (Zeilen-1-i)
					Next
				Case 11 'CoverJalousine von Unten nach Oben
					Local Value:Float = SpeedControl[0].GetValue(0,0)
					draw(PosX, PosY,,,, 0.75+0.25*Value)
					SetColor 255,255,255
					SetAlpha 1.0
					For Local i:Int = 0 To (1-Value)*(Zeilen-1)
						DrawImage CoverMosaik, PosX-HalfWidth, PosY-HalfHeight + i*CoverSize, i
					Next				
				Case 12 'CoverMosaik
					Local Value:Float = SpeedControl[0].GetValue(0,0)
					draw(PosX, PosY,,,, 0.75+0.25*Value)
					SetColor 255,255,255
					SetAlpha 1.0
					For Local i:Int = 0 To (1-Value)*CoverAnzahl-1
						DrawImage CoverMosaik, PosX-0.5*Spalten*CoverSize + (Verteilung[i] Mod Spalten)*CoverSize, PosY-0.5*Zeilen*CoverSize + (Verteilung[i] / Spalten)*CoverSize, Verteilung[i]
					Next
				'-------------------------------------------------------------------
				Case 13 'Aufgeregtes Hineindrehen
					Local Value:Float = SpeedControl[0].GetValue(0,1)
					draw(PosX, PosY, Value^2, Value^2, Value*540-180, 0.5+0.5*Value)
					SetScale 1.0, 1.0
					SetRotation 0
					SetAlpha 1.0
				'-------------------------------------------------------------------
				Case 14 'Zittern
					Local Value:Float = SpeedControl[0].GetValue(0,0)
					'If Rand(0,1) = 0 Then SetBlend LIGHTBLEND 'oder unntig?
					draw(PosX, PosY, 0.3*Value+0.7, 0.3*Value+0.7, Rand(-5*(1-Value), 5*(1-Value)), Value)
					SetBlend ALPHABLEND
					SetScale 1.0, 1.0
					SetRotation 0
					SetAlpha 1.0
				'-------------------------------------------------------------------
				Case 15 'Pseudo-3D-Hineinfliegen von Unten-Rechts mit Vertikaldrehung
					Local Value1:Float = 1-SpeedControl[0].GetValue(0,9)
					Local Value2:Float = SpeedControl[0].GetValue(0,0)
					Local Value3:Float = 0.25 + 0.75 * Value2
					Local Value4:Float = Value3*Cos(360*Value2)
					Local Value5:Float = 5*Sin(-90+270*SpeedControl[0].GetValue(0,5))
					draw(PosX+Value1*(GraphicsWidth()-HalfWidth-PosX), PosY+(1-Value2)*(GraphicsHeight()-HalfHeight-PosY), Value4, Value3, Value5, Value2)
					SetScale 1.0, 1.0
					SetRotation 0
					SetAlpha 1.0
				Case 16 'Pseudo-3D-Hineinfliegen von Unten(-Links) mit Horizontaldrehung
					Local Value2:Float = SpeedControl[0].GetValue(0,0)
					Local Value1:Float = 10*Sin(360*Value2)
					Local Value3:Float = 0.25 + 0.75 * Value2
					Local Value4:Float = Value3*Cos(360*Value2)
					Local Value5:Float = 5*Sin(-90+270*SpeedControl[0].GetValue(0,5))
					draw(0.5*PosX + 0.5*Value3*PosX-Value1, PosY+(1-Value2)*(GraphicsHeight()-HalfHeight-PosY), Value3, Value4, Value5, Value2)
					SetScale 1.0, 1.0
					SetRotation 0
					SetAlpha 1.0
				'-------------------------------------------------------------------
			End Select 'Style?
			'-------------------------------------------------------------------
		Else   'If SpeedControl[0] = Null Then
			If Style = 8 Or Style = 9 Then 'CoverJalousine aus Spalten
				Spalten = Min(HalfWidth, Max(2, CoverAnzahl))
				CoverSize = 2*HalfWidth / Spalten
				If CoverSize*Spalten < 2*HalfWidth Then CoverSize = CoverSize + 1
				Local GrabPM:TPixmap = GrabPixmap(PosX-HalfWidth, PosY-HalfHeight, Spalten*CoverSize, 2*HalfHeight)
				CoverMosaik = LoadAnimImage(GrabPM, CoverSize, 2*HalfHeight, 0, Spalten)
			ElseIf Style = 10 Or Style = 11 Then '
				Zeilen = Min(HalfHeight, Max(2, CoverAnzahl))
				CoverSize = 2*HalfHeight / Zeilen
				If CoverSize*Zeilen < 2*HalfHeight Then CoverSize = CoverSize + 1
				Local GrabPM:TPixmap = GrabPixmap(PosX-HalfWidth, PosY-HalfHeight, 2*HalfWidth, Zeilen*CoverSize)
				CoverMosaik = LoadAnimImage(GrabPM, 2*HalfWidth, CoverSize, 0, Zeilen)			
			ElseIf Style = 12 Then 'CoverMosaik
				CoverAnzahl = Min(400, Max(4, CoverAnzahl))
				CoverSize = Int(Sqr(4.0 * HalfWidth*HalfHeight / CoverAnzahl)) + 1
				Spalten = 2*HalfWidth / CoverSize
				If Spalten * CoverSize < 2*HalfWidth Then Spalten = Spalten + 1
				Zeilen = 2*HalfHeight / CoverSize
				If Zeilen * CoverSize < 2*HalfHeight Then Zeilen = Zeilen + 1
				CoverAnzahl = Spalten*Zeilen
				Local GrabPM:TPixmap = GrabPixmap(PosX-0.5*Spalten*CoverSize, PosY-0.5*Zeilen*CoverSize, Spalten*CoverSize, Zeilen*CoverSize)
				CoverMosaik = LoadAnimImage(GrabPM, CoverSize, CoverSize, 0, CoverAnzahl)
				Verteilung = CreatePermutation(CoverAnzahl)
			End If
			If ComeInSoundPath <> "" Then
				Local Sound:TSound = LoadSound(ComeInSoundPath)
				If Sound <> Null Then
					If Channel <> Null And ChannelPlaying(Channel) Then StopChannel(Channel)
					Channel = PlaySound(Sound)
				End If
			End If
			staystarttime = 0
			SpeedControl[1] = Null
			SpeedControl[2] = Null
			SpeedControl[0] = New TSpeedControl
			SpeedControl[0].Start()
		End If
		'===============================
	End Method   'comeIn()
	'===============================
	Method stay:Byte()
	'===============================
		SetColor RGB[0], RGB[1], RGB[2]
		If Image <> Null Then
			DrawImage Image, PosX, PosY
		ElseIf Gif = Null Then
			FontCollection.set(Fontfile, Fontsize)
			SetHandle HalfWidth, HalfHeight
			DrawText Text, PosX, PosY
		Else
			Gif.draw(PosX, PosY)
		End If
		If staystarttime <> 0 Then
			If KeyDown(KEY_ESCAPE) Then
				End
			ElseIf DelayTime = -1 Then
				 If KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or KeyDown(KEY_RIGHT) Or KeyDown(KEY_DOWN) Then
					aktiviert = False
					'FlushMouse()
					'FlushKeys()
					Return True
				End If
			ElseIf MilliSecs()-staystarttime >= DelayTime Then
				Return True
			End If
		Else   'If staystarttime = 0 Then
			SpeedControl[0] = Null
			SpeedControl[1] = Null
			SpeedControl[2] = Null
			staystarttime = MilliSecs()
			If StaySoundPath <> "" Then
				Local Sound:TSound = LoadSound(StaySoundPath)
				If Sound <> Null Then
					If Channel <> Null And ChannelPlaying(Channel) Then StopChannel(Channel)
					Channel = PlaySound(Sound)
				End If
			End If
		End If
	'===============================
	End Method   'stay()
	'===============================
	Method showAction:String()
	'===============================
		If Interaktion > 0 Then
		'--------------------------------------------------
			If aktiviert = True Then
				Select Interaktion
					Case 1   'Gehe zu Seite

						aktiviert = False
						GlobalElementActiv = False
						FlushMouse()
						FlushKeys()
						Return AktionsInfo

					Case 2   'Zeige Info
						SetHandle 0,0
						SetAlpha 0.75
						SetColor 0,0,0
						DrawRect 0,0,GraphicsWidth(), GraphicsHeight()
						SetColor 255,255,255
						SetAlpha 1.0
						DrawText AktionsInfo, (GraphicsWidth()-TextWidth(AktionsInfo))/2, (GraphicsHeight()-TextHeight(AktionsInfo))/2
						If MouseDown(1) Or MouseDown(2) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or KeyDown(KEY_ESCAPE) Or KeyDown(KEY_RIGHT) Or KeyDown(KEY_DOWN) Then
							aktiviert = False
							GlobalElementActiv = False
							FlushMouse()
							FlushKeys()
						End If

					Case 3   'Zeige Bild

						SetHandle 0,0
						SetAlpha 0.75
						SetColor 0,0,0
						DrawRect 0,0,GraphicsWidth(), GraphicsHeight()
						SetColor 255,255,255
						SetAlpha 1.0
						DrawImage AktionsBild, (GraphicsWidth()-ImageWidth(AktionsBild))/2, (GraphicsHeight()-ImageHeight(AktionsBild))/2
						If MouseDown(1) Or MouseDown(2) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_RETURN) Or KeyDown(KEY_ESCAPE) Or KeyDown(KEY_RIGHT) Or KeyDown(KEY_DOWN) Then
							aktiviert = False
							GlobalElementActiv = False
							FlushMouse()
							FlushKeys()
						End If

					Case 4   'Spiele Sound
						If InteractionChannel <> Null And ChannelPlaying(InteractionChannel) Then StopChannel(InteractionChannel)
						InteractionChannel = PlaySound(AktionsSound)
						aktiviert = False
						GlobalElementActiv = False
						FlushMouse()
						FlushKeys()

					Case 5   'Starte Skript

						system_(AppFile + " " + Chr(34) + AktionsInfo + Chr(34))
						aktiviert = False
						GlobalElementActiv = False
						FlushMouse()
						FlushKeys()

					Case 6   'ffne URL

						OpenURL(AktionsInfo)
						aktiviert = False
						GlobalElementActiv = False
						FlushMouse()
						FlushKeys()

					Case 7   'Ende
						End
				End Select
			ElseIf GlobalElementActiv = False Then
				Local Mx:Int = MouseX()
				Local My:Int = MouseY()
				If Mx >= PosX-HalfWidth And Mx <= PosX+HalfWidth And My >= PosY-HalfHeight And My <= PosY+HalfHeight Then
					SetHandle 0,0
					SetColor 255,0,0
					DrawRect PosX-HalfWidth-2, PosY-HalfHeight-2, 2*HalfWidth+4, 2
					DrawRect PosX-HalfWidth-2, PosY-HalfHeight-2, 2, 2*HalfHeight+4
					DrawRect PosX-HalfWidth-2, PosY+HalfHeight, 2*HalfWidth+4, 2
					DrawRect PosX+HalfWidth, PosY-HalfHeight-2, 2, 2*HalfHeight+4
					If MouseDown(1) Or MouseDown(2) Then
						aktiviert = True
						GlobalElementActiv = True
						FlushMouse()
						FlushKeys()
					End If
				End If
			End If
		'--------------------------------------------------
		End If   'Interaktion?
	'===============================
	End Method   'showAction:Byte()
'#################################
End Type   'TElement
'#################################
