'#################################
Type TPageChange
'#################################
	Global Channel:TChannel
	Field ScreenWidth:Int, ScreenHeight:Int, OldImage:TImage, NewImage:TImage, Style:Byte, SpeedControl:TSpeedControl
	Field OldPlain1:TPlainReduced1, NewPlain1:TPlainReduced1, OldPlain2:TPlainReduced2, NewPlain2:TPlainReduced2, PixelStep:Int
	Field Verteilung:Int[], Framesize:Int, FrameCount:Int, Spalten:Int, Sound:TSound
	'===============================
	Function build:TPageChange(OldPage:TPixmap, NewPage:TPixmap, ChangeStyle:Byte = 0, PixelStep:Int = 4, Soundpath:String = "")
		Local NTPC:TPageChange = New TPageChange
		NTPC.ScreenWidth = GraphicsWidth()
		NTPC.ScreenHeight = GraphicsHeight()
		NTPC.Style = ChangeStyle
		NTPC.PixelStep = PixelStep
		Local StyleTauglich:Byte = True
		
'Die Stylenummern sind nach ihren Anforderungen an den Computer angeordnet:
'---- Niedrigste Stufe Performance-Anforderungen ----
		
		If NTPC.Style <= 8 Then
			NTPC.OldImage = LoadImage(OldPage)
			NTPC.NewImage = LoadImage(NewPage)
			If NTPC.Style = 1 Then   'Spotlight
				MidHandleImage(NTPC.NewImage)
			ElseIf NTPC.Style = 2 Or NTPC.Style = 3 Then 'Drehscheibe
				SetImageHandle(NTPC.OldImage, 0, NTPC.ScreenHeight)
				SetImageHandle(NTPC.NewImage, 0, NTPC.ScreenHeight)
			ElseIf NTPC.Style = 4 Then   'Simple "Entfernen-Schleuse"
				MidHandleImage(NTPC.OldImage)
				MidHandleImage(NTPC.NewImage)
			End If

'---- Nchste Stufe Performance-Anforderungen ----
			
		ElseIf NTPC.Style = 9 Then 'Alpha-Abblttern
			Local TestSize:Int = 8
			Repeat
				NTPC.Spalten = NTPC.ScreenWidth/TestSize
				If NTPC.Spalten*TestSize = NTPC.ScreenWidth Then
					NTPC.FrameSize = TestSize
					NTPC.NewImage = LoadAnimImage(NewPage, NTPC.FrameSize, NTPC.ScreenHeight, 0, NTPC.Spalten)
					NTPC.OldImage = LoadImage(OldPage)
					Exit
				End If
				TestSize = TestSize - 1
			Until TestSize < 2
			If TestSize < 2 Then StyleTauglich = False 'falls keine Einteilung mglich, MUSS eben ein anderer Style herhalten

		ElseIf NTPC.Style = 10 Then 'Alpha-Aufblttern
			Local TestSize:Int = 8
			Repeat
				NTPC.Spalten = NTPC.ScreenWidth/TestSize
				If NTPC.Spalten*TestSize = NTPC.ScreenWidth Then
					NTPC.FrameSize = TestSize
					NTPC.OldImage = LoadAnimImage(OldPage, NTPC.FrameSize, NTPC.ScreenHeight, 0, NTPC.Spalten)
					NTPC.NewImage = LoadImage(NewPage)
					Exit
				End If
				TestSize = TestSize - 1
			Until TestSize < 2
			If TestSize < 2 Then StyleTauglich = False 'falls keine Einteilung mglich, MUSS eben ein anderer Style herhalten:

		ElseIf NTPC.Style <= 16 Then 'Mosaiken
			Local tests:Byte, TestSpaltenanzahl:Int[] = [8,10,9,12,16,15]
			Repeat
				NTPC.FrameSize = NTPC.ScreenWidth/TestSpaltenanzahl[tests]
				NTPC.Spalten = TestSpaltenanzahl[tests]
				Local Reihen:Int = NTPC.ScreenHeight/NTPC.FrameSize
				If NTPC.Spalten*NTPC.FrameSize = NTPC.ScreenWidth And Reihen*NTPC.FrameSize = NTPC.ScreenHeight Then
					NTPC.FrameCount = NTPC.Spalten*Reihen
					NTPC.Verteilung = New Int[NTPC.FrameCount]
					If NTPC.Style = 13 Then
						Local Rfg:Int[] = CreatePermutation(Reihen, 4^((-1)^Rand(0,1)))
						Local Nr:Int[Reihen,NTPC.Spalten]
						Local Index:Int[Reihen]
						For Local i:Int = 0 To Reihen-1
							For Local j:Int = 0 To NTPC.Spalten-1
								Nr[Rfg[i],j] = i*NTPC.Spalten + NTPC.Spalten-1 - j
							Next
						Next
						Local i:Int = 0
						Repeat
							For Local j:Int = 0 To Reihen-1
								If i >= 2*j And Index[j] <= NTPC.Spalten-1 Then
									NTPC.Verteilung[i] = Nr[j, Index[j]]
									Index[j] = Index[j] + 1
									i = i + 1
								End If
							Next
						Until i >= NTPC.FrameCount
					ElseIf NTPC.Style = 14 Then
						'Local Rfg:Int[NTPC.Spalten] = [3,4,2,5,1,6,0,7]
						Local Rfg:Int[]
						If NTPC.Spalten = 8 Then
							Rfg = [3,4,2,5,1,6,0,7]
						ElseIf NTPC.Spalten <= 10 Then
							Rfg = [4,5,3,6,2,7,1,8,0,9]
						ElseIf NTPC.Spalten = 12 Then
							Rfg = [5,6,4,7,3,8,2,9,1,10,0,11]
						Else  'If NTPC.Spalten <= 16 Then
							Rfg = [7,8,6,9,5,10,4,11,3,12,2,13,1,14,0,15]
						End If
						Local Nr:Int[NTPC.Spalten,Reihen]
						Local Index:Int[NTPC.Spalten]
						For Local i:Int = 0 To NTPC.Spalten-1
							For Local j:Int = 0 To Reihen-1
								Nr[i,j] = Rfg[i] + j*NTPC.Spalten
							Next
						Next
						Local i:Int = 0
						Repeat
							For Local j:Int = 0 To NTPC.Spalten-1
								If i >= 2*j And Index[j] <= Reihen-1 Then
									NTPC.Verteilung[i] = Nr[j, Index[j]]
									Index[j] = Index[j] + 1
									i = i + 1
								End If
							Next
						Until i >= NTPC.FrameCount
					ElseIf NTPC.Style = 12 Or NTPC.Style = 15 Or NTPC.Style = 16 Then
						NTPC.Verteilung = CreatePermutation(NTPC.FrameCount)
					End If
					If NTPC.Style <> 11 Then
						NTPC.OldImage = LoadAnimImage(OldPage, NTPC.FrameSize, NTPC.FrameSize, 0, NTPC.FrameCount)
						MidHandleImage(NTPC.OldImage)
					Else   'If NTPC.Style = 11 Then
						NTPC.OldImage = LoadImage(OldPage)
					End If
					NTPC.NewImage = LoadAnimImage(NewPage, NTPC.FrameSize, NTPC.FrameSize, 0, NTPC.FrameCount)
					MidHandleImage(NTPC.NewImage)
					tests = 7  'Zeichen, die Schleife (erfolgreich!) abzubrechen
				End If
				tests = tests+1
			Until tests >= 6
			If tests = 6 Then StyleTauglich = False 'falls keine Einteilung mglich, MUSS eben ein anderer Style herhalten:

		ElseIf NTPC.Style = 17 Then 'Mosaik, VIELE Platten fallen alle herunter
			Local tests:Byte, TestSpaltenanzahl:Int[] = [16,15,12,10,9,8]   '[8,10,9,12,16,15]
			Repeat
				NTPC.FrameSize = NTPC.ScreenWidth/TestSpaltenanzahl[tests]
				Local Reihen:Int = NTPC.ScreenHeight/NTPC.FrameSize
				If TestSpaltenanzahl[tests]*NTPC.FrameSize = NTPC.ScreenWidth And Reihen*NTPC.FrameSize = NTPC.ScreenHeight Then
					NTPC.Spalten = TestSpaltenanzahl[tests]
					NTPC.FrameCount = NTPC.Spalten*Reihen
					NTPC.OldImage = LoadAnimImage(OldPage, NTPC.FrameSize, NTPC.FrameSize, 0, NTPC.FrameCount)
					MidHandleImage(NTPC.OldImage)
					NTPC.NewImage = LoadImage(NewPage)
					NTPC.Verteilung = CreatePermutation(NTPC.FrameCount)
					tests = 7  'Zeichen, die Schleife (erfolgreich!) abzubrechen
					Exit
				End If
				NTPC.FrameSize = NTPC.FrameSize - 1
				tests = tests+1
			Until tests >=6
			If tests = 6 Then StyleTauglich = False 'falls keine Einteilung mglich, MUSS eben ein anderer Style herhalten:

'---- Nchste Stufe Performance-Anforderungen ----

		ElseIf NTPC.Style = 18 Then 	'3D-Seite kippt nach vorn
			NTPC.OldPlain1 = TPlainReduced1.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.0*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewImage = LoadImage(NewPage)
		ElseIf NTPC.Style = 19 Then '3D-Seite fliegt herein (mit Drehung nach Unten)
			NTPC.OldImage = LoadImage(OldPage)
			NTPC.NewPlain1 = TPlainReduced1.build([0.0, 0.0, 5.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight, 5.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 5.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenWidth, 0.0, 5.0*NTPC.ScreenWidth], NewPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 20 Then '3D-Seite fliegt herein (mit Rechtsdrehung)
			NTPC.OldImage = LoadImage(OldPage)
			NTPC.NewPlain2 = TPlainReduced2.build([0.0, 0.0, 5.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight, 5.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 5.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenWidth, 0.0, 5.0*NTPC.ScreenWidth], NewPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 21 Then   '3D-Verdrehen bzw. -Umdrehen von Oben nach Unten
			Local TestSize:Int = 4   'oder doch grber = 8 ?
			Repeat
				NTPC.Spalten = NTPC.ScreenHeight/TestSize
				If NTPC.Spalten*TestSize = NTPC.ScreenHeight Then
					NTPC.FrameSize = TestSize
					NTPC.NewImage = LoadAnimImage(NewPage, NTPC.ScreenWidth, NTPC.FrameSize, 0, NTPC.Spalten)
					NTPC.OldImage = LoadAnimImage(OldPage, NTPC.ScreenWidth, NTPC.FrameSize, 0, NTPC.Spalten)
					SetImageHandle(NTPC.NewImage, 0.5*ScreenWidth, 0.0)
					SetImageHandle(NTPC.OldImage, 0.5*ScreenWidth, 0.0)
					Exit
				End If
				TestSize = TestSize - 1
			Until TestSize < 2
			If TestSize < 2 Then StyleTauglich = False 'falls keine Einteilung mglich, MUSS eben ein anderer Style herhalten
		ElseIf NTPC.Style = 22 Then   '3D-Verdrehen bzw. -Umdrehen von Links nach Rechts
			Local TestSize:Int = 4   'oder doch grber = 8 ?
			Repeat
				NTPC.Spalten = NTPC.ScreenWidth/TestSize
				If NTPC.Spalten*TestSize = NTPC.ScreenWidth Then
					NTPC.FrameSize = TestSize
					NTPC.NewImage = LoadAnimImage(NewPage, NTPC.FrameSize, NTPC.ScreenHeight, 0, NTPC.Spalten)
					NTPC.OldImage = LoadAnimImage(OldPage, NTPC.FrameSize, NTPC.ScreenHeight, 0, NTPC.Spalten)
					SetImageHandle(NTPC.NewImage, 0.0, 0.5*ScreenHeight)
					SetImageHandle(NTPC.OldImage, 0.0, 0.5*ScreenHeight)
					Exit
				End If
				TestSize = TestSize - 1
			Until TestSize < 2
			If TestSize < 2 Then StyleTauglich = False 'falls keine Einteilung mglich, MUSS eben ein anderer Style herhalten
		ElseIf NTPC.Style <= 24 Then '3D-Tren ffnen sich oben und unten
			NTPC.NewImage = LoadImage(NewPage)  'i.F. NICHT im Sinne von "old" bzw. "new", sondern Oben und Unten:
			MidHandleImage(NTPC.NewImage)   'SetImageHandle(NTPC.NewImage, 0.5*ScreenWidth, 1.0*ScreenHeight)
			Local OneSide:TPixmap = CreatePixmap(1.0*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, PF_BGRA8888)
			PixmapPaste(OneSide, OldPage, 0, 0)
			Local Another:TPixmap = CreatePixmap(1.0*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, PF_BGRA8888)
			PixmapPaste(Another, OldPage, 0.0, -0.5*NTPC.ScreenHeight)
			NTPC.OldPlain1 = TPlainReduced1.build([0.0, 0.0, 0.0, 0.0, 0.5*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OneSide, 0.25*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain1 = TPlainReduced1.build([0.0, 0.5*NTPC.ScreenHeight, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, 0.0], Another, 0.25*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style <= 26 Then '3D-Tren ffnen sich seitlich
			NTPC.NewImage = LoadImage(NewPage)  'i.F. NICHT im Sinne von "old" bzw. "new", sondern Links und Rechts:
			SetImageHandle(NTPC.NewImage, 0.5*ScreenWidth, 1.0*ScreenHeight)
			Local OneSide:TPixmap = CreatePixmap(0.5*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, PF_BGRA8888)
			PixmapPaste(OneSide, OldPage, 0, 0)
			Local Another:TPixmap = CreatePixmap(0.5*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, PF_BGRA8888)
			PixmapPaste(Another, OldPage, -0.5*NTPC.ScreenWidth, 0)
			NTPC.OldPlain2 = TPlainReduced2.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 0.5*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 0.5*NTPC.ScreenWidth, 0.0, 0.0], OneSide, 0.25*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain2 = TPlainReduced2.build([0.5*NTPC.ScreenWidth, 0.0, 0.0, 0.5*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], Another, 0.25*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)

'---- Nchste Stufe Performance-Anforderungen ----
			
		ElseIf NTPC.Style = 27 Then '3D-Quader dreht nach Unten
			NTPC.OldPlain1 = TPlainReduced1.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain1 = TPlainReduced1.build([0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight], NewPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 28 Then '3D-Quader dreht nach Oben
			NTPC.OldPlain1 = TPlainReduced1.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain1 = TPlainReduced1.build([0.0, 1.0*NTPC.ScreenHeight, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0], NewPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 29 Then '3D-Raumecke dreht nach Unten
			NTPC.OldPlain1 = TPlainReduced1.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain1 = TPlainReduced1.build([0.0, 0.0, -1.0*NTPC.ScreenHeight, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0, 1.0*NTPC.ScreenWidth, 0.0, -1.0*NTPC.ScreenHeight], NewPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 30 Then '3D-Raumecke dreht nach Oben
			NTPC.OldPlain1 = TPlainReduced1.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain1 = TPlainReduced1.build([0.0, 1.0*NTPC.ScreenHeight, 0.0, 0.0, 1.0*NTPC.ScreenHeight, -1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, -1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0], NewPage, 1.5*NTPC.ScreenHeight, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)

'---- Hchste Stufe Performance-Anforderungen ----

		ElseIf NTPC.Style = 31 Then '3D-Quader dreht nach Links
			NTPC.OldPlain2 = TPlainReduced2.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain2 = TPlainReduced2.build([1.0*NTPC.ScreenWidth, 0.0, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenWidth], NewPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 32 Then '3D-Quader dreht nach Rechts
			NTPC.OldPlain2 = TPlainReduced2.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain2 = TPlainReduced2.build([0.0, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight, 1.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 0.0, 0.0, 0.0], NewPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 33 Then '3D-Raumecke dreht nach Links
			NTPC.OldPlain2 = TPlainReduced2.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain2 = TPlainReduced2.build([1.0*NTPC.ScreenWidth, 0.0, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, -1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenWidth, 0.0, -1.0*NTPC.ScreenWidth], NewPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
		ElseIf NTPC.Style = 34 Then '3D-Raumecke dreht nach Rechts
			NTPC.OldPlain2 = TPlainReduced2.build([0.0, 0.0, 0.0, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 1.0*NTPC.ScreenHeight, 0.0, 1.0*NTPC.ScreenWidth, 0.0, 0.0], OldPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)
			NTPC.NewPlain2 = TPlainReduced2.build([0.0, 0.0, -1.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight, -1.0*NTPC.ScreenWidth, 0.0, 1.0*NTPC.ScreenHeight, 0.0, 0.0, 0.0, 0.0], NewPage, 1.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenWidth, 0.5*NTPC.ScreenHeight, NTPC.PixelStep)

		End If 'NTPC.Style?
		'-----------------------------------------
		'--- Notanker bei untauglichem Style: ---
		If StyleTauglich = False Then
			NTPC.Style = Rand(0,8)
			NTPC.OldImage = LoadImage(OldPage)
			NTPC.NewImage = LoadImage(NewPage)
			If NTPC.Style = 1 Or NTPC.Style = 2 Then
				SetImageHandle(NTPC.OldImage, 0, NTPC.ScreenHeight)
				SetImageHandle(NTPC.NewImage, 0, NTPC.ScreenHeight)
			End If
		End If
		'-----------------------------------------
		If Soundpath <> "" Then NTPC.Sound = LoadSound(Soundpath)
		'-----------------------------------------
		Return NTPC	
	'===============================
	End Function
	'===============================
	Method show:Byte(Period:Int = 2000)  'Taugliche Werte zwischen 1000 und 3000
	'===============================
		If SpeedControl <> Null Then
			SetAlpha 1.0
			SetScale 1.0, 1.0
			SetColor 255,255,255
			SetRotation 0
			Cls
			SpeedControl.UpdateTime()
			SpeedControl.UpdateStates(Period)
			Local Value1:Float
			'---------------------------------------------------
			Select Style
				Case 0 'Alphablende
					Value1 = SpeedControl.GetValue(0,0)
					SetAlpha 1-Value1
					DrawImage OldImage, 0, 0
					SetAlpha Value1
					DrawImage NewImage, 0, 0

				Case 1   'Spotlight
					Value1 = SpeedControl.GetValue(0, 0)
					DrawImage OldImage, 0, 0
					Local Value2:Float = (0.125-0.125*Cos(Value1*360))*Screenheight
					Local x:Float = (ScreenWidth/2)*(1-Value1) - Value2*Cos(Value1*720)
					Local y:Float = (ScreenHeight/2)*(1-Value1) + Value2*Sin(Value1*720)
					SetAlpha Value1
					SetViewport(x, y, (0.7*SpeedControl.GetValue(0, 3)+0.3)*ScreenWidth,  (0.7*SpeedControl.GetValue(0, 3)+0.3)*ScreenHeight)
					DrawImage NewImage, ScreenWidth/2, ScreenHeight/2
					SetViewport(0, 0, ScreenWidth, ScreenHeight)
					SetAlpha 1.0
										
				Case 2 'Drehscheibe abwrts
					Value1 = SpeedControl.GetValue(0,3)
					SetRotation Value1*90
					DrawImage OldImage, 0, ScreenHeight
					SetRotation Value1*90-90
					DrawImage NewImage, 0, ScreenHeight
					
				Case 3 'Drehscheibe aufwrts
					Value1 = SpeedControl.GetValue(0,3)
					SetRotation -Value1*90
					DrawImage OldImage, 0, ScreenHeight
					SetRotation 90-Value1*90
					DrawImage NewImage, 0, ScreenHeight

				Case 4   'Simple "Entfernen-Schleuse"
					Value1 = 1-SpeedControl.GetValue(0, 14)
					SetScale 1+Value1, 1+Value1
					DrawImage NewImage, ScreenWidth/2, ScreenHeight/2
					SetScale 1.0, 1.0
					SetAlpha Value1
					SetColor 0,0,0
					DrawPoly( [ 0.0, 0.0, ScreenWidth/2.0, ScreenHeight/2.0, 0.0, 1.0*ScreenHeight ] )
					DrawPoly( [ 1.0*ScreenWidth, 0.0, ScreenWidth/2.0, ScreenHeight/2.0, 1.0*ScreenWidth, 1.0*ScreenHeight ] )
					SetColor 255,255,255
					DrawPoly( [ 0.0, 0.0, ScreenWidth/2.0, ScreenHeight/2.0, 1.0*ScreenWidth,  0.0 ] )
					DrawPoly( [ 0.0, 1.0*ScreenHeight, ScreenWidth/2.0, ScreenHeight/2.0, 1.0*ScreenWidth, 1.0*ScreenHeight ] )
					SetAlpha 1.0
					SetScale Value1, Value1
					DrawImage OldImage, ScreenWidth/2, ScreenHeight/2
					
				Case 5 'Verschieben nach Links (scheinbar 3D mit Reflexion)
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = 1-0.4*Sin(Value1*180)
					SetScale Value2, Value2
					DrawImage OldImage, (1-Value2-Value1)*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight
					DrawImage NewImage, (1-Value1)*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight
					SetAlpha 0.3
					SetScale Value2, -Value2
					DrawImage OldImage, (1-Value2-Value1)*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight+2*Value2*ScreenHeight
					DrawImage NewImage, (1-Value1)*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight+2*Value2*ScreenHeight
					SetAlpha 1.0
					
				Case 6 'Verschieben nach Rechts (scheinbar 3D mit Reflexion)
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = 1-0.4*Sin(Value1*180)
					SetScale Value2, Value2
					DrawImage OldImage, Value1*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight
					DrawImage NewImage, (Value1-Value2)*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight
					SetAlpha 0.3
					SetScale Value2, -Value2
					DrawImage OldImage, Value1*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight+2*Value2*ScreenHeight
					DrawImage NewImage, (Value1-Value2)*1.05*ScreenWidth, 0.5*(1-Value2)*ScreenHeight+2*Value2*ScreenHeight
					SetAlpha 1.00
					
				Case 7  'Verschieben UND ZOOMEN nach Links (scheinbar 3D mit Reflexion)
					Value1 = SpeedControl.GetValue(0,1)
					SetAlpha 1-0.5*Value1
					SetScale 1-Value1, 1-Value1
					DrawImage OldImage, -Value1*0.05*ScreenHeight, 0.5*Value1*ScreenHeight
					SetAlpha 0.5+0.5*Value1
					SetScale Value1, Value1
					DrawImage NewImage, (1-Value1)*1.05*ScreenWidth, 0.5*(1-Value1)*ScreenHeight
					SetAlpha 0.3-0.15*Value1
					SetScale 1-Value1, Value1-1
					DrawImage OldImage, -Value1*0.05*ScreenHeight, 0.5*Value1*ScreenHeight+2*(1-Value1)*ScreenHeight
					SetAlpha 0.15+0.15*Value1
					SetScale Value1, -Value1
					DrawImage NewImage, (1-Value1)*1.05*ScreenWidth, 0.5*(1-Value1)*ScreenHeight+2*Value1*ScreenHeight
					
				Case 8  'Verschieben UND ZOOMEN nach Rechts (scheinbar 3D mit Reflexion)
					Value1 = SpeedControl.GetValue(0,1)
					SetAlpha 1-0.5*Value1
					SetScale 1-Value1, 1-Value1
					DrawImage OldImage, Value1*1.05*ScreenWidth, 0.5*Value1*ScreenHeight
					SetAlpha 0.5+0.5*Value1
					SetScale Value1, Value1
					DrawImage NewImage, -(1-Value1)*0.05*ScreenHeight, 0.5*(1-Value1)*ScreenHeight
					SetAlpha 0.3-0.15*Value1
					SetScale 1-Value1, Value1-1
					DrawImage OldImage, Value1*1.05*ScreenWidth, 0.5*Value1*ScreenHeight+2*(1-Value1)*ScreenHeight
					SetAlpha 0.15+0.15*Value1
					SetScale Value1, -Value1
					DrawImage NewImage, -(1-Value1)*0.05*ScreenHeight, 0.5*(1-Value1)*ScreenHeight+2*Value1*ScreenHeight
					
				Case 9 'Alpha-Abblttern von Links nach Rechts
					Value1 = SpeedControl.GetValue(0,0)
					SetColor 255-Value1*200, 255-Value1*200, 255-Value1*200
					DrawImage OldImage, 0,0
					Local Overlap:Int = Spalten/4.0
					For Local i:Int = 0 To Spalten-1
						Local Value2:Float = Max(0, Min(1, ((Spalten - 1 + Overlap) * Value1 - i) / Overlap))	
						SetAlpha Value2
						SetScale 1.0, 1.05-0.05*Value2
						SetColor 255*Value2, 255*Value2, 255*Value2
						DrawImage NewImage, i*FrameSize, -0.1*ScreenHeight*(1-Value2)*(1-Value1), i
					Next
					SetAlpha 1.0
					SetScale 1.0, 1.0
					
				Case 10 'Alpha-Aufblttern von Rechts nach Links
					Value1 = 1-SpeedControl.GetValue(0,0)
					SetColor 255-Value1*200, 255-Value1*200, 255-Value1*200
					DrawImage NewImage, 0,0
					Local Overlap:Int = Spalten/4.0
					For Local i:Int = 0 To Spalten-1
						Local Value2:Float = Max(0, Min(1, ((Spalten - 1 + Overlap) * Value1 - i) / Overlap))	
						SetAlpha Value2
						SetScale 1.0, 1.05-0.05*Value2
						SetColor 255*Value2, 255*Value2, 255*Value2
						DrawImage OldImage, i*FrameSize, -0.1*ScreenHeight*(1-Value2)*(1-Value1), i
					Next
					SetAlpha 1.0
					SetScale 1.0, 1.0
					SetColor 255,255,255
					
				Case 11 'Mosaik, Rasterzooming
					Value1 = SpeedControl.GetValue(0,0)
					SetColor 255-Value1*255, 255-Value1*255, 255-Value1*255
					DrawImage OldImage, 0,0
					SetColor Value1*255, Value1*255, Value1*255
					SetScale Value1, Value1
					For Local i:Int = 0 To Framecount-1
						DrawImage NewImage, FrameSize/2 + (i Mod Spalten)*FrameSize, FrameSize/2 + (i / Spalten)*FrameSize, i
					Next
					SetScale 1.0, 1.0

				Case 12 'Mosaik, Diamantenblitz
					Value1 = SpeedControl.GetValue(0,0)
					Local Overlap:Int = FrameCount/3			
					For Local i:Int = 0 To Framecount-1
						Local Value2:Float = Max(0, Min(1, ((FrameCount - 1 + Overlap) * Value1 - i) / Overlap))	
						Local Value3:Float = 0.5*(1+Cos(360*Value2))
						SetScale Value3, Value3
						If Value2 < 0.5 Then
							DrawImage OldImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						Else
							DrawImage NewImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						End If
					Next

				Case 13 'Mosaik, Platten drehen sich (scheinbar 3D) von Rechts nach Links
					Value1 = SpeedControl.GetValue(0,0)
					Local Overlap:Int = FrameCount/3 '?				
					For Local i:Int = 0 To Framecount-1
						Local Value2:Float = Max(0, Min(1, ((FrameCount - 1 + Overlap) * Value1 - i) / Overlap))
						Local Value3:Float = 0.5*(1+Cos(360*Value2))
						SetRotation (5-Value3*5)*(-1)^i
						SetColor 55+200*Value3, 55+200*Value3, 55+200*Value3
						SetScale Value3, 0.95+0.05*Value3
						If Value2 < 0.5 Then
							DrawImage OldImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						Else						
							DrawImage NewImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						End If
					Next
					
				Case 14 'Mosaik, Platten drehen sich (scheinbar 3D) von Oben nach Unten
					Value1 = SpeedControl.GetValue(0,0)
					Local Overlap:Int = FrameCount/2 '?				
					For Local i:Int = 0 To Framecount-1
						Local Value2:Float = Max(0, Min(1, ((FrameCount - 1 + Overlap) * Value1 - i) / Overlap))
						Local Value3:Float = 0.5*(1+Cos(360*Value2))
						SetRotation (5-Value3*5)*(-1)^i
						SetColor 55+200*Value3, 55+200*Value3, 55+200*Value3
						SetScale 0.95+0.05*Value3, Value3
						If Value2 < 0.5 Then
							DrawImage OldImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						Else						
							DrawImage NewImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						End If
					Next
					
				Case 15 'Mosaik, Permutations-Puzzle
					Value1 = SpeedControl.GetValue(0,1)
					Local Overlap:Int = FrameCount '?				
					For Local i:Int = 0 To Framecount-1
						Local Fx:Float = (FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize)*(1-Value1) + (FrameSize/2 + (i Mod Spalten)*FrameSize)*Value1
						Local Fy:Float = (FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize)*(1-Value1) + (FrameSize/2 + (i / Spalten)*FrameSize)*Value1
						SetAlpha 1-Value1
						DrawImage OldImage, Fx, Fy, Verteilung[i]
						SetAlpha Value1
						DrawImage NewImage, Fx, Fy, i
					Next
					
				Case 16 'Mosaik, Platten drehen sich jeweils um ihren Mittelpunkt "zurecht"
					Value1 = SpeedControl.GetValue(0,0)
					Local Overlap:Int = FrameCount/3			
					For Local i:Int = 0 To Framecount-1
						Local Value2:Float = Max(0, Min(1, ((FrameCount - 1 + Overlap) * Value1 - i) / Overlap))
						Value2 = (-15.466208*Value2^6+55.748769*Value2^5-72.065513*Value2^4+37.111655*Value2^3-4.614007*Value2^2+0.285305*Value2)
						SetAlpha 1-Value2
						SetRotation (-1)^i*90*Value2
						DrawImage OldImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
						SetAlpha Value2
						SetRotation (-1)^i*(90*Value2-90)
						DrawImage NewImage, FrameSize/2 + (Verteilung[i] Mod Spalten)*FrameSize, FrameSize/2 + (Verteilung[i] / Spalten)*FrameSize, Verteilung[i]
					Next
					
				Case 17 'Mosaik, VIELE Teile fallen alle herunter
					Local ValueArray:Float[] = [SpeedControl.getValue(0,14), SpeedControl.getValue(0,3), Float(SpeedControl.getValue(0,3)^1.5)]
					SetColor 155+ValueArray[0]*100, 155+ValueArray[0]*100, 155+ValueArray[0]*100
					DrawImage NewImage, 0,0
					SetColor 255,255,255
					For Local j:Int = 0 To Framecount-1
						Local i:Int = (Framecount-1)-j
						Local iMod:Int = i Mod 3
						Local Y1:Float = FrameSize/2 + (i / Spalten)*FrameSize
						SetRotation ValueArray[0]*(ScreenHeight-Y1)*((-1)^i)
						Y1 = (1-ValueArray[iMod])*Y1 + ValueArray[iMod]*(ScreenHeight + FrameSize)
						DrawImage OldImage, FrameSize/2 + (i Mod Spalten)*FrameSize, Y1, i
					Next
					SetRotation 0

				Case 18 '3D-Seite kippt nach vorn
					Value1 = SpeedControl.GetValue(0,3)
					DrawImage NewImage, 0, 0
					OldPlain1.reset()
					OldPlain1.rotate_xAxis([ScreenWidth/2.0, 1.0*ScreenHeight, 0.0], 81*Value1)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					OldPlain1.draw()
					SetColor 255,255,255
					SetScale 1.0, 1.0

				Case 19 '3D-Seite fliegt herein (mit Drehung nach Unten)
					Local Value2:Float = SpeedControl.GetValue(0,1)
					SetColor 255-Value2*155, 255-Value2*155, 255-Value2*155
					DrawImage OldImage, 0, 0
					Value1 = SpeedControl.GetValue(0,13)
					NewPlain1.reset()
					NewPlain1.move_zDirection(-5.0*ScreenWidth*Value1)
					NewPlain1.rotate_xAxis([ScreenWidth/2.0, ScreenHeight/2.0, 0.5*(NewPlain1.Poly3D[2]+NewPlain1.Poly3D[11])], -90.0+450.0*Value1)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					SetColor 0,0,0   'Erst den Schatten:
					SetAlpha 0.1+0.4*Value2
					Local ZweiAchse:Float = (0.6*ScreenHeight+0.5*ScreenHeight*Value2)
					Local Abweichung:Float = 0.5*(1-Value2)*(NewPlain1.Poly2D[1]-NewPlain1.Poly2D[3])
					DrawPoly([NewPlain1.Poly2D[0], ZweiAchse-Abweichung, NewPlain1.Poly2D[2], ZweiAchse+Abweichung, NewPlain1.Poly2D[4], ZweiAchse+Abweichung, NewPlain1.Poly2D[6], ZweiAchse-Abweichung])
					SetAlpha 1.0
					NewPlain1.draw()   'dann die Hauptsache
					SetScale 1.0, 1.0
					SetRotation 0

				Case 20 '3D-Seite fliegt herein (mit Rechtsdrehung)
					Local Value2:Float = SpeedControl.GetValue(0,1)
					SetColor 255-Value2*155, 255-Value2*155, 255-Value2*155
					DrawImage OldImage, 0, 0
					Value1 = SpeedControl.GetValue(0,13)
					NewPlain2.reset()
					NewPlain2.move_zDirection(-5.0*ScreenWidth*Value1)
					NewPlain2.rotate_yAxis([ScreenWidth/2.0, ScreenHeight/2.0, 0.5*(NewPlain2.Poly3D[2]+NewPlain2.Poly3D[11])], -90.0+450.0*Value1)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					SetColor 0,0,0   'Erst den Schatten:
					SetAlpha 0.1+0.2*Value2
					Local ZweiAchse:Float = (0.6*ScreenHeight+0.6*ScreenHeight*Value2)
					Local Abweichung1:Float = 0.5*(1-Value2)*(NewPlain2.Poly2D[1]-NewPlain2.Poly2D[3])
					Local Abweichung2:Float = -0.5*(1-Value2)*(NewPlain2.Poly2D[5]-NewPlain2.Poly2D[7])
					DrawPoly([NewPlain2.Poly2D[0], ZweiAchse-Abweichung1, NewPlain2.Poly2D[2], ZweiAchse+Abweichung1, NewPlain2.Poly2D[4], ZweiAchse+Abweichung2, NewPlain2.Poly2D[6], ZweiAchse-Abweichung2])
					SetAlpha 1.0
					NewPlain2.draw()   'dann die Hauptsache
					SetScale 1.0, 1.0
					SetRotation 0

				Case 21   '3D-Umdrehen bzw. -Verdrehen von Oben nach Unten
					Value1 = SpeedControl.GetValue(0, 0)
					Local Overlap:Int = Spalten*2
					For Local i:Int = 0 To Spalten-1
						Local Value2:Float = Max(0, Min(1, ((Spalten - 1 + Overlap) * Value1 - i) / Overlap))	
						Local Value3:Float = Sin(180*Value2-90)	
						Local Value4:Int = 255*Value3
						If Value3 = -1 Then
							SetColor 255, 255, 255
							SetScale 1.0, 1.0
							SetRotation 0
							DrawImage OldImage, 0.5*ScreenWidth, i*FrameSize, i
						ElseIf Value3 < 0 Then
							SetColor -Value4, -Value4, -Value4
							SetScale -Value3, 1.3333
							SetRotation (1+Value3)*45
							DrawImage OldImage, 0.5*ScreenWidth, i*FrameSize, i
						ElseIf Value3 < 1 Then
							SetColor Value4, Value4, Value4
							SetScale Value3, 1.3333
							SetRotation (Value3-1)*45
							DrawImage NewImage, 0.5*ScreenWidth, i*FrameSize, i
						Else   'If Value3 < 1 Then
							SetColor 255, 255, 255
							SetScale 1.0, 1.0
							SetRotation 0
							DrawImage NewImage, 0.5*ScreenWidth, i*FrameSize, i
						End If
					Next

				Case 22   '3D-Umdrehen bzw. -Verdrehen von Links nach Rechts
					Value1 = SpeedControl.GetValue(0, 0)
					Local Overlap:Int = Spalten*2
					For Local i:Int = 0 To Spalten-1
						Local Value2:Float = Max(0, Min(1, ((Spalten - 1 + Overlap) * Value1 - i) / Overlap))	
						Local Value3:Float = Sin(180*Value2-90)	
						Local Value4:Int = 255*Value3
						If Value3 = -1 Then
							SetColor 255, 255, 255
							SetScale 1.0, 1.0
							SetRotation 0
							DrawImage OldImage, i*FrameSize, 0.5*ScreenHeight, i
						ElseIf Value3 < 0 Then
							SetColor -Value4, -Value4, -Value4
							SetScale 1.2, -Value3
							SetRotation (1+Value3)*45
							DrawImage OldImage, i*FrameSize, 0.5*ScreenHeight, i
						ElseIf Value3 < 1 Then
							SetColor Value4, Value4, Value4
							SetScale 1.2, Value3
							SetRotation (Value3-1)*45
							DrawImage NewImage, i*FrameSize, 0.5*ScreenHeight, i
						Else   'If Value3 < 1 Then
							SetColor 255, 255, 255
							SetScale 1.0, 1.0
							SetRotation 0
							DrawImage NewImage, i*FrameSize, 0.5*ScreenHeight, i							
						End If
					Next

				Case 23   '3D-Tren ffnen sich oben und unten, neues Bild wartet erst und kommt dann hervor
					Value1 = SpeedControl.GetValue(0,1)
					OldPlain1.reset()
					OldPlain1.rotate_xAxis([ 0.5*ScreenWidth, 0.0, 0.0], +100.0*Value1)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					NewPlain1.reset()
					NewPlain1.rotate_xAxis([0.5*ScreenWidth, 1.0*ScreenHeight, 0.0], -100.0*Value1)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					Local Value2:Float = 0.3+0.7*SpeedControl.GetValue(0,2)^10
					If Value1 < 0.75 Then
						SetScale Value2, Value2
						DrawImage NewImage, 0.5*ScreenWidth, 0.5*ScreenHeight
						OldPlain1.draw()
						NewPlain1.draw()
					Else
						OldPlain1.draw()
						NewPlain1.draw()
						SetScale Value2, Value2
						DrawImage NewImage, 0.5*ScreenWidth, 0.5*ScreenHeight
					End If

				Case 24   '3D-Tren ffnen sich oben und unten (mit zwz.Rckbewegung), neues Bild liegt dahinter
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenWidth*0.5
					OldPlain1.reset()
					OldPlain1.rotate_xAxis([ 0.5*ScreenWidth, 0.0, 0.0],  -90.0*Value1)
					OldPlain1.move_zDirection(Value2)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					NewPlain1.reset()
					NewPlain1.rotate_xAxis([0.5*ScreenWidth, 1.0*ScreenHeight, 0.0],  90.0*Value1)
					NewPlain1.move_zDirection(Value2)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					Local Value3:Float = 1.0*(OldPlain1.Poly2D[6] - OldPlain1.Poly2D[0] - 8.0*(1-Value1)) / ScreenWidth
					SetScale Value3, Value3
					SetAlpha Value1
					DrawImage NewImage, 0.5*ScreenWidth, 0.5*ScreenHeight
					SetAlpha 1.0
					OldPlain1.draw()
					NewPlain1.draw()

				Case 25 '3D-Tren ffnen sich seitlich nach hinten, neues Bild schwebt reflektierend herein
					Value1 = SpeedControl.GetValue(0,1)
					OldPlain2.reset()
					OldPlain2.rotate_yAxis([0.0, 0.5*ScreenHeight, 0.0], +90.0*Value1)
					OldPlain2.calculate_Shades_and_3D_to_2D()
					OldPlain2.draw()
					NewPlain2.reset()
					NewPlain2.rotate_yAxis([1.0*ScreenWidth, 0.5*ScreenHeight, 0.0], -90.0*Value1)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					NewPlain2.draw()
					SetAlpha Value1
					Local Value2:Float = SpeedControl.GetValue(0,3)
					Local Value3:Float = SpeedControl.GetValue(0,14)
					SetScale Value2, Value2
					DrawImage NewImage, 0.5*ScreenWidth, Value3*ScreenHeight
					SetScale Value2, -0.75*Value2
					SetAlpha 0.25*Value1
					DrawImage NewImage, 0.5*ScreenWidth, Value3*ScreenHeight

				Case 26 '3D-Tren ffnen sich seitlich nach vorne (mit zwz.Rckbewegung), neues Bild liegt dahinter
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenWidth*0.5
					OldPlain2.reset()
					OldPlain2.rotate_yAxis([0.0, 0.5*ScreenHeight, 0.0], -90.0*Value1)
					OldPlain2.move_zDirection(Value2)
					OldPlain2.calculate_Shades_and_3D_to_2D()
					NewPlain2.reset()
					NewPlain2.rotate_yAxis([1.0*ScreenWidth, 0.5*ScreenHeight, 0.0], +90.0*Value1)
					NewPlain2.move_zDirection(Value2)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					Local Value3:Float = 1.0*(NewPlain2.Poly2D[6] - OldPlain2.Poly2D[0] - 8.0*(1-Value1)) / ScreenWidth
					SetScale Value3, Value3
					SetAlpha Value1
					DrawImage NewImage, 0.5*ScreenWidth, OldPlain2.Poly2D[3]
					SetAlpha 0.25*Value1
					SetScale Value3, -0.75*Value3
					DrawImage NewImage, 0.5*ScreenWidth, OldPlain2.Poly2D[3]
					SetAlpha 1.0
					SetScale 1.0, 1.0
					SetColor 0,0,0
					DrawPoly([OldPlain2.Poly2D[2], OldPlain2.Poly2D[3], OldPlain2.Poly2D[2], 1.0*ScreenHeight, OldPlain2.Poly2D[4], 1.0*ScreenHeight, OldPlain2.Poly2D[4], OldPlain2.Poly2D[5]])
					DrawPoly([NewPlain2.Poly2D[2], NewPlain2.Poly2D[3], NewPlain2.Poly2D[2], 1.0*ScreenHeight, NewPlain2.Poly2D[4], 1.0*ScreenHeight, NewPlain2.Poly2D[4], NewPlain2.Poly2D[5]])
					OldPlain2.draw()
					NewPlain2.draw()
					
				Case 27 '3D-Quader dreht nach Unten
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*0.75*ScreenHeight
					OldPlain1.reset()
					OldPlain1.rotate_xAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenHeight/2.0], 90.0*Value1)
					OldPlain1.move_zDirection(Value2)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					NewPlain1.reset()
					NewPlain1.rotate_xAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenHeight/2.0], 90.0*Value1)
					NewPlain1.move_zDirection(Value2)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					If Value1 < 0.5 Then
						NewPlain1.draw()
						OldPlain1.draw()
					Else
						OldPlain1.draw()
						NewPlain1.draw()
					End If
					
				Case 28 '3D-Quader dreht nach Oben
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*0.75*ScreenHeight
					OldPlain1.reset()
					OldPlain1.rotate_xAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenHeight/2.0], -90.0*Value1)
					OldPlain1.move_zDirection(Value2)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					NewPlain1.reset()
					NewPlain1.rotate_xAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenHeight/2.0], -90.0*Value1)
					NewPlain1.move_zDirection(Value2)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					If Value1 < 0.5 Then
						NewPlain1.draw()
						OldPlain1.draw()
					Else
						OldPlain1.draw()
						NewPlain1.draw()
					End If
					
				Case 29 '3D-Raumecke dreht nach Unten
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenHeight*0.25
					Local Value3:Float = SpeedControl.GetValue(0,3)
					OldPlain1.reset()
					OldPlain1.move_zDirection(-Value3*ScreenHeight+Value2)
					OldPlain1.rotate_xAxis([ScreenWidth/2.0, OldPlain1.Poly3D[7], OldPlain1.Poly3D[8]], -90.0*Value1)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					OldPlain1.draw()
					NewPlain1.reset()
					NewPlain1.move_zDirection(-Value3*ScreenHeight+Value2)
					NewPlain1.rotate_xAxis([ScreenWidth/2.0, OldPlain1.Poly3D[7], OldPlain1.Poly3D[8]], -90.0*Value1)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					NewPlain1.draw()
					
				Case 30 '3D-Raumecke dreht nach Oben
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenHeight*0.25
					Local Value3:Float = SpeedControl.GetValue(0,3)
					OldPlain1.reset()
					OldPlain1.move_zDirection(-Value3*ScreenHeight+Value2)
					OldPlain1.rotate_xAxis([ScreenWidth/2.0, OldPlain1.Poly3D[1], OldPlain1.Poly3D[2]], 90.0*Value1)
					OldPlain1.calculate_Shades_and_3D_to_2D()
					OldPlain1.draw()
					NewPlain1.reset()
					NewPlain1.move_zDirection(-Value3*ScreenHeight+Value2)
					NewPlain1.rotate_xAxis([ScreenWidth/2.0, OldPlain1.Poly3D[1], OldPlain1.Poly3D[2]], 90.0*Value1)
					NewPlain1.calculate_Shades_and_3D_to_2D()
					NewPlain1.draw()
					
				Case 31 '3D-Quader dreht nach Links
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenWidth/3
					OldPlain2.reset()
					OldPlain2.rotate_yAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenWidth/2.0], -90.0*Value1)
					OldPlain2.move_zDirection(Value2)
					OldPlain2.calculate_Shades_and_3D_to_2D()
					NewPlain2.reset()
					NewPlain2.rotate_yAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenWidth/2.0], -90.0*Value1)
					NewPlain2.move_zDirection(Value2)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					If Value1 < 0.5 Then
						NewPlain2.draw()
						OldPlain2.draw()
					Else
						OldPlain2.draw()
						NewPlain2.draw()
					End If

				Case 32 '3D-Quader dreht nach Rechts
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenWidth/3
					OldPlain2.reset()
					OldPlain2.rotate_yAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenWidth/2.0], 90.0*Value1)
					OldPlain2.move_zDirection(Value2)
					OldPlain2.calculate_Shades_and_3D_to_2D()
					NewPlain2.reset()
					NewPlain2.rotate_yAxis([ScreenWidth/2.0, ScreenHeight/2.0, ScreenWidth/2.0], 90.0*Value1)
					NewPlain2.move_zDirection(Value2)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					If Value1 < 0.5 Then
						NewPlain2.draw()
						OldPlain2.draw()
					Else
						OldPlain2.draw()
						NewPlain2.draw()
					End If

				Case 33 '3D-Raumecke dreht nach Links
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenWidth*0.25
					Local Value3:Float = SpeedControl.GetValue(0,3)
					OldPlain2.reset()
					OldPlain2.move_zDirection(-Value3*ScreenWidth+Value2)
					OldPlain2.rotate_yAxis([OldPlain2.Poly3D[0], ScreenHeight/2.0, OldPlain2.Poly3D[2]], 90.0*Value1)
					OldPlain2.calculate_Shades_and_3D_to_2D()
					OldPlain2.draw()
					NewPlain2.reset()
					NewPlain2.move_zDirection(-Value3*ScreenWidth+Value2)
					NewPlain2.rotate_yAxis([OldPlain2.Poly3D[0], ScreenHeight/2.0, OldPlain2.Poly3D[2]], 90.0*Value1)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					NewPlain2.draw()
					
				Case 34 '3D-Raumecke dreht nach Rechts
					Value1 = SpeedControl.GetValue(0,1)
					Local Value2:Float = Sin(180*Value1)*ScreenWidth*0.25
					Local Value3:Float = SpeedControl.GetValue(0,3)
					OldPlain2.reset()
					OldPlain2.move_zDirection(-Value3*ScreenWidth+Value2)
					OldPlain2.rotate_yAxis([OldPlain2.Poly3D[9], ScreenHeight/2.0, OldPlain2.Poly3D[11]], -90.0*Value1)
					OldPlain2.calculate_Shades_and_3D_to_2D()
					OldPlain2.draw()
					NewPlain2.reset()
					NewPlain2.move_zDirection(-Value3*ScreenWidth+Value2)
					NewPlain2.rotate_yAxis([OldPlain2.Poly3D[9], ScreenHeight/2.0, OldPlain2.Poly3D[11]], -90.0*Value1)
					NewPlain2.calculate_Shades_and_3D_to_2D()
					NewPlain2.draw()

				'------------------------------------------------------------------------------------------------------------------------------------------------------
				Default
					Return True
			End Select
			'---------------------------------------------------
			Flip
			'---------------------------------------------------
			If SpeedControl.Duration >= Period Then
				SetColor 255,255,255
				SetRotation 0
				SetScale 1.0, 1.0
				SetAlpha 1.0
				Return True
			End If
		Else   'If SpeedControl = Null
			'----------------------------------
			If Sound <> Null Then PlaySound(Sound)
			'----------------------------------
			SpeedControl = New TSpeedControl
			SpeedControl.Start()
		End If
	'===============================
	End Method   'show()
	'===============================
'#################################
End Type   'TPageChange
'#################################
