'###################################################################
Type TPlainReduced1
'###################################################################
	Field Poly3D:Float[], MemoPoly3D:Float[], DynamicImage:TDynamicImageReduced1
	Field Poly2D:Float[], CentralX:Float, CentralY:Float, Shade:Int[2], ShadeDistance:Int
	'----------------------------------------------------------------------------------------------------------------------
	Function build:TPlainReduced1(NewPolygon3D:Float[], Pixmap:TPixmap, ShadeDistance:Int, NewCentralX:Float, NewCentralY:Float, PixelStep:Int)
		Local NT3DS:TPlainReduced1 = New TPlainReduced1
		NT3DS.Poly2D = New Float[8]
		NT3DS.DynamicImage = TDynamicImageReduced1.build(Pixmap, PixelStep)
		NT3DS.CentralX = NewCentralX
		NT3DS.CentralY = NewCentralY
		NT3DS.ShadeDistance = ShadeDistance
		NT3DS.Shade = New Int[2]
		NT3DS.set(NewPolygon3D)
		Return NT3DS
	End Function   'build
	'----------------------------------------------------------------------------------------------------------------------
	Method set(NewPoly3D:Float[] = Null)
		If NewPoly3D <> Null Then
			Poly3D = New Float[12]
			MemoPoly3D = New Float[12]
			For Local i:Int = 0 To 11
				Poly3D[i] = NewPoly3D[i]
				MemoPoly3D[i] = NewPoly3D[i]
			Next
			calculate_Shades_and_3D_to_2D()
		Else   '(nur zum Zweck der Memorisierung fr sptere Resets)
			For Local i:Int = 0 To 11
				MemoPoly3D[i] = Poly3D[i]
			Next
		End If
	End Method   '(set)
	'----------------------------------------------------------------------------------------------------------------------
	Method Reset() 'zurcksetzen auf Ausgangpolygon3D
		For Local i:Int = 0 To 11
			Poly3D[i] = MemoPoly3D[i]
		Next
	End Method   '(Reset)
	'----------------------------------------------------------------------------------------------------------------------
	Method move_zDirection(ZDirection:Float) 'Umrechnung der 3D-Koocdinaten bei Bewegungen
		Poly3D[2] = Poly3D[2] + ZDirection
		Poly3D[5] = Poly3D[5] + ZDirection
		Poly3D[8] = Poly3D[8] + ZDirection
		Poly3D[11] = Poly3D[11] + ZDirection
	End Method   '(move)
	'----------------------------------------------------------------------------------------------------------------------
	Method rotate_xAxis(FixPoint:Float[], xAxisValue:Float)
		'------------------------------------------------------
		Local Distance:Float, TempAngle:Float
		'------------------------------------------------------
		For Local i:Int = 1 To 10 Step 3
			Distance = Sqr( (Poly3D[i]-FixPoint[1])^2 + (Poly3D[i+1]-FixPoint[2])^2 )
			TempAngle = xAxisValue + ATan2( Poly3D[i+1]-FixPoint[2], Poly3D[i]-FixPoint[1] )
			Poly3D[i] = FixPoint[1] + Distance * Cos(TempAngle)
			Poly3D[i+1] = FixPoint[2] + Distance * Sin(TempAngle)
		Next
		'------------------------------------------------------
	End Method   '(rotate)
	'----------------------------------------------------------------------------------------------------------------------
	Method calculate_Shades_and_3D_to_2D()
		Local Z_Difference:Int = Poly3D[2] + Poly3D[11] - Poly3D[5] - Poly3D[8]
		If  Z_Difference >= 0 Then
			Shade[0] = Min(191, 191.0 * Z_Difference / ShadeDistance)
			Shade[1] = 0
		Else
			Shade[0] = 0
			Shade[1] = Min(191, -191.0 * Z_Difference / ShadeDistance)
		End If
		'---------------------------------------------------------------------------------------------------
		Poly2D[0] = CentralX + (Poly3D[0] - CentralX) / (1.00075^Poly3D[2])
		Poly2D[1] = CentralY + (Poly3D[1] - CentralY) / (1.00075^Poly3D[2])
		Poly2D[2] = CentralX + (Poly3D[3] - CentralX) / (1.00075^Poly3D[5])
		Poly2D[3] = CentralY + (Poly3D[4] - CentralY) / (1.00075^Poly3D[5])	
		Poly2D[4] = CentralX + (Poly3D[6] - CentralX) / (1.00075^Poly3D[8])
		Poly2D[5] = CentralY + (Poly3D[7] - CentralY) / (1.00075^Poly3D[8])
		Poly2D[6] = CentralX + (Poly3D[9] - CentralX) / (1.00075^Poly3D[11])
		Poly2D[7] = CentralY + (Poly3D[10] - CentralY) / (1.00075^Poly3D[11])
	End Method   '(calculate_Shades_and_3D_to_2D)
	'----------------------------------------------------------------------------------------------------------------------
	Method draw()
		DynamicImage.Draw(Poly2D, [ 255-Shade[0], 255-Shade[0], 255-Shade[0] ], [ 255-Shade[1], 255-Shade[1], 255-Shade[1] ] )
	End Method   '(draw)
'###################################################################
End Type   '(TPlainReducedReduced1)
'###################################################################

'###################################################################
Type TPlainReduced2
'###################################################################
	Field Poly3D:Float[], MemoPoly3D:Float[], DynamicImage:TDynamicImageReduced2
	Field Poly2D:Float[], CentralX:Float, CentralY:Float, Shade:Int[2], ShadeDistance:Int
	'----------------------------------------------------------------------------------------------------------------------
	Function build:TPlainReduced2(NewPolygon3D:Float[], Pixmap:TPixmap, ShadeDistance:Int, NewCentralX:Float, NewCentralY:Float, PixelStep:Int)
		Local NT3DS:TPlainReduced2 = New TPlainReduced2
		NT3DS.Poly2D = New Float[8]
		NT3DS.DynamicImage = TDynamicImageReduced2.build(Pixmap, PixelStep)
		NT3DS.CentralX = NewCentralX
		NT3DS.CentralY = NewCentralY
		NT3DS.ShadeDistance = ShadeDistance
		NT3DS.Shade = New Int[2]
		NT3DS.set(NewPolygon3D)
		Return NT3DS
	End Function   'build
	'----------------------------------------------------------------------------------------------------------------------
	Method set(NewPoly3D:Float[] = Null)
		If NewPoly3D <> Null Then
			Poly3D = New Float[12]
			MemoPoly3D = New Float[12]
			For Local i:Int = 0 To 11
				Poly3D[i] = NewPoly3D[i]
				MemoPoly3D[i] = NewPoly3D[i]
			Next
			calculate_Shades_and_3D_to_2D()
		Else   '(nur zum Zweck der Memorisierung fr sptere Resets)
			For Local i:Int = 0 To 11
				MemoPoly3D[i] = Poly3D[i]
			Next
		End If
	End Method   '(set)
	'----------------------------------------------------------------------------------------------------------------------
	Method Reset() 'zurcksetzen auf Ausgangpolygon3D
		For Local i:Int = 0 To 11
			Poly3D[i] = MemoPoly3D[i]
		Next
	End Method   '(Reset)
	'----------------------------------------------------------------------------------------------------------------------
	Method move_zDirection(ZDirection:Float) 'Umrechnung der 3D-Koocdinaten bei Bewegungen
		Poly3D[2] = Poly3D[2] + ZDirection
		Poly3D[5] = Poly3D[5] + ZDirection
		Poly3D[8] = Poly3D[8] + ZDirection
		Poly3D[11] = Poly3D[11] + ZDirection
	End Method   '(move)
	'----------------------------------------------------------------------------------------------------------------------
	Method rotate_yAxis(FixPoint:Float[], yAxisValue:Float)
		'------------------------------------------------------
		Local Distance:Float, TempAngle:Float
		'------------------------------------------------------
		For Local i:Int = 0 To 9 Step 3
			Distance = Sqr( (Poly3D[i]-FixPoint[0])^2 + (Poly3D[i+2]-FixPoint[2])^2 )
			TempAngle = yAxisValue + ATan2( Poly3D[i+2]-FixPoint[2], Poly3D[i]-FixPoint[0] )
			Poly3D[i] = FixPoint[0] + Distance * Cos(TempAngle)
			Poly3D[i+2] = FixPoint[2] + Distance * Sin(TempAngle)
		Next
		'------------------------------------------------------
		'calculate_Shades_and_3D_to_2D()
	End Method   '(rotate)
	'----------------------------------------------------------------------------------------------------------------------
	Method calculate_Shades_and_3D_to_2D()
		Local Z_Difference:Int = Poly3D[2] + Poly3D[5] - Poly3D[8] - Poly3D[11]
		If  Z_Difference >= 0 Then
			Shade[0] = Min(191, 191.0 * Z_Difference / ShadeDistance)
			Shade[1] = 0
		Else
			Shade[0] = 0
			Shade[1] = Min(191, -191.0 * Z_Difference / ShadeDistance)
		End If
		'---------------------------------------------------------------------------------------------------
		Poly2D[0] = CentralX + (Poly3D[0] - CentralX) / (1.00075^Poly3D[2])
		Poly2D[1] = CentralY + (Poly3D[1] - CentralY) / (1.00075^Poly3D[2])
		Poly2D[2] = CentralX + (Poly3D[3] - CentralX) / (1.00075^Poly3D[5])
		Poly2D[3] = CentralY + (Poly3D[4] - CentralY) / (1.00075^Poly3D[5])	
		Poly2D[4] = CentralX + (Poly3D[6] - CentralX) / (1.00075^Poly3D[8])
		Poly2D[5] = CentralY + (Poly3D[7] - CentralY) / (1.00075^Poly3D[8])
		Poly2D[6] = CentralX + (Poly3D[9] - CentralX) / (1.00075^Poly3D[11])
		Poly2D[7] = CentralY + (Poly3D[10] - CentralY) / (1.00075^Poly3D[11])
	End Method   '(calculate_Shades_and_3D_to_2D)
	'----------------------------------------------------------------------------------------------------------------------
	Method draw()
		DynamicImage.Draw(Poly2D, [ 255-Shade[0], 255-Shade[0], 255-Shade[0] ], [ 255-Shade[1], 255-Shade[1], 255-Shade[1] ] )
	End Method   '(draw)
'###################################################################
End Type   '(TPlainReducedReduced2)
'###################################################################
