'#################################
Type TSpeedControl
'#################################
	Field StartTime:Int, RealStartPoint:Int, Now:Int, Duration:Int, Repetitions:Int
	Field GeneralState:Float, AbsState:Float[7], Sign:Int[7], ControlKeys:Int[], ControlMouseKeys:Int[]
	'===============================
	Method Start()
	'===============================
		StartTime = MilliSecs()
		Duration = 0
		Repetitions = 0
	'-------------------------------------------------------
	End Method   'Start()
	'===============================
	Method UpdateTime()
	'===============================
		Now = MilliSecs()
		Duration = Now - StartTime
	'-------------------------------------------------------
	End Method   'Start()
	'===============================
	Method UpdateStates(Period:Int, Waiting:Int = 0)   'Bitte beachten: "Period" MUSS grer als 0 sein!
	'===============================
		RealStartPoint = StartTime + Waiting
		Repetitions = (Now - RealStartPoint) / Period
		GeneralState = 1.0 * ((Now - RealStartPoint) - Repetitions*Period) / Period
		AbsState = [GeneralState, GeneralState, GeneralState, GeneralState, GeneralState, GeneralState, GeneralState]
		Sign = [+1, +1, +1, +1, +1, +1, +1]
		If Now >= RealStartPoint Then 'Now AFTER RealStartPoint
			If Repetitions > 0 Then
				AbsState[0] = 1
				If Repetitions Mod 2 = 1 Then
					AbsState[2] = 1 - GeneralState
					AbsState[3] = AbsState[2]
					AbsState[5] = AbsState[2]
					AbsState[6] = AbsState[2]
				End If
				If Repetitions Mod 4 > 1 Then
					Sign[3] = -1
					Sign[6] = -1
				End If	
			End If
		Else   'Now BEFORE RealStartPoint
			AbsState[0] = 0
			AbsState[1] = 0
			AbsState[2] = 0
			AbsState[3] = 0
			AbsState[4] = GeneralState + 1
			If Repetitions Mod 2 = 0 Then		
				AbsState[5] = Abs(GeneralState)
			Else   'If Repetitions Mod 2 = 1 Then
				AbsState[5] = GeneralState + 1
			End If
			AbsState[6] = AbsState[5]
			If Repetitions Mod 4 > -2 Then
				Sign[6] = -1
			End If	
		End If
	'-------------------------------------------------------
	End Method   'Update()
	'===============================
	Method GetValue:Float(Way:Byte, Style:Byte = 0)
	'===============================
		Select Style
			Case 1	
				Return Sign[Way] * 0.5*(1-Cos(180.0*AbsState[Way]))
			Case 2
				Return Sign[Way] * (-15.466208*AbsState[Way]^6+55.748769*AbsState[Way]^5-72.065513*AbsState[Way]^4+37.111655*AbsState[Way]^3-4.614007*AbsState[Way]^2+0.285305*AbsState[Way])
			Case 3
				Return Sign[Way] * AbsState[Way]^3
			Case 4
				Return Sign[Way] * ((AbsState[Way] - 1) ^ 5 + 1)
			Case 5
				Return Sign[Way] * (-2.404*AbsState[Way]^6+26.38991*AbsState[Way]^5-52.68866*AbsState[Way]^4+34.27283*AbsState[Way]^3-4.82741*AbsState[Way]^2+0.25734*AbsState[Way])
			Case 6
				Return Sign[Way] * (-2.65747*AbsState[Way]^4 + 6.64292*AbsState[Way]^3 - 3.13238*AbsState[Way]^2 + 0.14694*AbsState[Way])
			Case 7
				Return Sign[Way] * (3.07613*AbsState[Way]^4-5.19295*AbsState[Way]^3+0.21918*AbsState[Way]^2+2.89764*AbsState[Way])
			Case 8
				Return Sign[Way] * (AbsState[Way]^5 - 1.0 * Sin(360.0 * AbsState[Way]) / 8)
			Case 9
				Return Sign[Way] * ((AbsState[Way] - 1) ^ 3 + 1 - 1.0 * Sin(360.0 * AbsState[Way]) / 8)
			Case 10
				Return Sign[Way] * (28.525016*AbsState[Way]^5-71.312541*AbsState[Way]^4+55.364035*AbsState[Way]^3-11.733512*AbsState[Way]^2+0.157001*AbsState[Way])
			Case 11
				Return Sign[Way] * (223.232745*AbsState[Way]^7 - 781.314608*AbsState[Way]^6 + 1015.715451*AbsState[Way]^5 - 586.002108*AbsState[Way]^4 + 132.108039*AbsState[Way]^3 - 2.817255*AbsState[Way]^2 + 0.077735*AbsState[Way])
			Case 12
				Return Sign[Way] * (471.877602*AbsState[Way]^7 -1651.571606*AbsState[Way]^6 + 2203.462422*AbsState[Way]^5 - 1379.727038*AbsState[Way]^4 + 394.238249*AbsState[Way]^3 - 37.416139*AbsState[Way]^2 + 0.136511*AbsState[Way])
			Case 13
				Return Sign[Way] * Sin(90*AbsState[Way])
			Case 14
				Return Sign[Way] * (1-Cos(90*AbsState[Way]))
			Case 15
				Return Sign[Way] * Int(2 * AbsState[Way] + 1) / 2
			Default 'Case 0
				Return Sign[Way] * AbsState[Way]
		End Select
	'-------------------------------------------------------
	End Method   'GetValue
	'===============================
	Method CreateWaitingSequence:Int[](TotalPeriod:Int, SinglePeriod:Int, Count:Int, Order:Byte, TotalWaiting:Int = 0)
	'===============================
		Local SingleWaiting:Int[Count]
		Local RestTime:Int = TotalPeriod - SinglePeriod
		Select Order
			Case 0   'first 0, then rising
				For Local s:Int = 0 To Count-1
					SingleWaiting[s] = 1.0 * s * RestTime / Count +  TotalWaiting
				Next
			Case 1   'first Count-1, then sloping
				For Local s:Int = 0 To Count-1
					SingleWaiting[Count-1-s] = 1.0 * s * RestTime / Count +  TotalWaiting
				Next
			Case 2   'first the center Count/2, then outside to the two ends
				For Local s:Int = 0 To Count/2
					SingleWaiting[s] = (Count/2.0 - s) * 2.0 * RestTime / Count + TotalWaiting
					SingleWaiting[Count-1-s] = SingleWaiting[s]
				Next
			Case 3   'first the two ends, then inside to the center Count/2
				For Local s:Int = 0 To Count/2
					SingleWaiting[s] = s * 2.0 * RestTime / Count + TotalWaiting
					SingleWaiting[Count-1-s] = SingleWaiting[s]
				Next
			Case 4   'ordered Random: Everyone on another time
				Local Permutation:Int[] = CreatePermutation(Count)
				For Local s:Int = 0 To Count-1
					SingleWaiting[Permutation[s]] = 1.0 * s * RestTime / Count +  TotalWaiting
				Next
			Default   'absolutely Chaos-Random
				For Local s:Int = 0 To Count-1
					SingleWaiting[s] = Rand(0, RestTime) +  TotalWaiting
				Next
		End Select
		Return SingleWaiting
	'-------------------------------------------------------
	End Method   'CreateWaitingSequence()
	'===============================
	Method SetUserControl(NewKeys:Int[] = Null, NewMouseKeys:Int[] = Null)
	'===============================
		If NewKeys = Null Then
			ControlKeys = [KEY_SPACE, KEY_RETURN, KEY_RIGHT, KEY_DOWN]
		Else
			ControlKeys = NewKeys
		End If
		If NewMouseKeys = Null Then
			ControlMouseKeys = [1,2]
		Else
			ControlMouseKeys = NewMouseKeys
		End If
	'-------------------------------------------------------
	End Method   'SetUserControl()
	'===============================
	Method GetUserControl:Int()
	'===============================
		For Local key:Int = 0 To Len(ControlKeys)-1
			If KeyDown(ControlKeys[key]) = True Then Return ControlKeys[key]	
		Next
		For Local mousekey:Int = 0 To Len(ControlMouseKeys)-1
			If MouseDown(ControlMouseKeys[mousekey]) = True Then Return ControlMouseKeys[mousekey]
		Next
	'-------------------------------------------------------
	End Method   'GetUserControl()
	'===============================
'#################################
End Type
'#################################