SuperStrict

Framework BRL.GLMax2D

Import BRL.Retro

Import BRL.System

SetGraphicsDriver( GLMax2DDriver() )

AppTitle = "NSTC - Waiting for script..."

Local codefile:String

If AppArgs.length > 1

	codefile = Replace(AppArgs[1] , Chr(34), "")
	
	AppTitle = "NSTC - "+codefile

Else

	codefile = RequestFile("Script ffnen:", "Scripte:cf; Textdateien:txt; Alle Dateien:*")
	
	AppTitle = "NSTC - "+codefile

EndIf


FlushKeys

Local sc:TScript = New TScript

If sc.Load(codefile, 100) = 0 

AppTitle = "NSTC - Error!"

Notify(codefile+Chr(13)+"Script konnte nicht geladen werden!", 1)

End

Else

AppTitle = "NSTC - "+codefile

EndIf

sc.Execute() 'Script ausfhren


' Types

Type TGoto

	Field name:String
	Field line:Int

EndType

Const Typ_Int:Byte = 1, Typ_Float:Byte = 2, Typ_String:Byte = 3
		
Type Array

	Field name:String
	Field typ:Byte
	Field iarray:Int[]
	Field farray:Float[]
	Field sarray:String[]
	Field amount:Int
	
EndType

Type IVar

	Field Name:String
	Field value:Int
	
EndType

Type FVar
	
	Field Name:String
	Field Value:Float

EndType

Type SVar
	
	Field Name:String
	Field value:String

EndType

Type TScript 'Haupttype fr Scripts

	'Fields
	Field lines:String[] 'Zeilen des geladenen Scripts
	Field anz:Int 'Anzahl der Zeilen
	Field IVars:TList
	Field FVars:TList
	Field SVars:TList
	Field Arrays:TList
	Field TGotos:TList
	Field file:String
	

	'Methoden
	Method Load:Int(file:String, maxlines:Int) 'Methode um Script zu Laden (file: Pfad zum Script; maxlines: Maximale Zeilenanzahl)
	
		Local go:TGoto
		
		Self.file = file
	
		Self.lines = New String[maxlines]
		
		Self.IVars = New TList
		
		Self.FVars = New TList
		
		Self.SVars = New TList
		
		Self.Arrays = New TList
		
		Self.TGotos = New TList
		
		Local istr:TStream = ReadStream(file)
		
		Local line:String
		
		If istr = Null Return 0
		
		While Not Eof(istr)
		
			line = ReadLine$(istr)
			
			Self.lines[Self.anz] = line$
			
			If Left(line,1) = "#" 'Goto
				
				go = New TGoto
				
				go.name = Self.Calc2(Right(line, Len(line)-1))
				
				go.line = Self.anz
				
				Self.TGotos.AddLast(go)
						
			EndIf	
			
			Self.anz = Self.anz + 1
		
		Wend
		
		CloseFile istr 
		
		Return 1
	
	EndMethod
	
	Method Execute() ' Methode zum Ausfhren eines Scriptes (Quiet: Unsichtbare Ausfhrung)#
	
		Print "Beginne Ausfuehrung des Scriptes <"+Self.file+">"
		
		SeedRnd(MilliSecs())
		
		'Variablendeklarationen (Fr SuperStrict)
		Local i:Int 'Zeilenzhler
		
		Local ln:String, cmd:String 'Zeile, Befehl
		
		Local pstr:String, pstru:String 'Text von Print
		
		Local lzpos:Int, lpos:Int, kapos:Int, leerpos:Int, gzpos:Int, k1pos:Int, k2pos:Int, k3pos:Int, k4pos:Int 'Leerzeichenposition, Linksposition, Kommaposition, Leerzeichenposition, Gleichposition,Komma(1)position, Komma(2)position, etc..
		
		Local ekapos:Int, ekzpos:Int
		
		Local cr:Int, cg:Int, cb:Int 'Farben fr Farbbefehle
		
		Local xpos:Int, ypos:Int 'X- und Y-Position
		
		Local width:Int, height:Int 'Breite und Hhe
		
		Local p1:Int, p2:Float, p3:String
		
		Local iv:IVar, fv:FVar, sv:SVar, arr:Array, val:String 'VariablenTypes
		
		Local Input_Text:SVar = New SVar
		
		Input_Text.Name = "input_text"
		
		Self.SVars.AddLast(Input_Text)
		
		Local stppos:Int 'Position des Kommentars
		
		Local eop:Int, Ifc:Int, go:TGoto, cmdv:Int 'Ende des Programms, Anzahl der offenen Ifs, Der Goto-Type, Befehl vorhanden?
		
		'Abarbeiten des Scriptes		
		For i = 0 To Self.anz
		
			ln$ = Self.lines[i]
			
			If Left(ln,1) = ";" Continue
			
			stppos = Instr(ln, ";")
			
			If stppos > 0 ln = Left(ln, stppos-1)
			
			lzpos = Instr(ln$, " ")
			kapos = Instr(ln$, "(")
			
			If lzpos = 0
			
				lpos = kapos 
			
			Else 
			
				lpos = lzpos
			
			EndIf
			
			If lpos = 0 
			
				cmd$ = ln$
			
			Else
			
				cmd$ = Left(ln$, lpos-1)
			
			EndIf
			
			cmd$ = Lower(cmd$)
						
			If cmd = "endif"
				
				If ifc > 0
							
					ifc = ifc - 1
						
				EndIf

				cmdv = 1
			
			EndIf
			
					
			leerpos = Instr(ln$," ")
					
			k1pos = Instr(ln$,",")
			
			k2pos = Instr(ln$,",",k1pos+1)
			
			k3pos = Instr(ln,",",k2pos+1)
			
			k4pos = Instr(ln,",",k3pos+1)
			
			If ifc < 1
			
				'Befehlauswertung Rest
				Select cmd$
				
					Case "int"
						
						lzpos = Instr(ln, " ", leerpos+1)
						
						If Lower(Mid(ln, leerpos+1, lzpos-leerpos-1)) = "dim" 'Array?
						
							ekapos = Instr(ln, "[")
							
							ekzpos = Instr(ln, "]")
						
							arr:Array = New Array
							
							arr.name = Replace(Mid(ln, lzpos+1, ekapos-lzpos-1), " ", "")
							
							arr.typ = Typ_Int
							
							p1 = Int(Mid(ln, ekapos+1, ekzpos-ekapos-1))
							
							arr.IArray = New Int[p1]
							
							arr.amount = p1
							
							Self.Arrays.AddLast(arr)
						
						Else
						
							gzpos = Instr(ln$, "=")
							
							iv:IVar = New IVar
							
							iv.name = Replace(Mid(ln, leerpos+1, gzpos-leerpos-1), " ", "")
							
							val = Right(ln, Len(ln)-gzpos)
							
							iv.value = Int(Self.Calc2(val))
							
							Self.IVars.AddLast(iv)
						
						EndIf
						
					Case "float"
						
						gzpos = Instr(ln$, "=")
						
						lzpos = Instr(ln, " ", leerpos+1)
						
						If Lower(Mid(ln, leerpos+1, lzpos-leerpos-1)) = "dim" 'Array?
						
							ekapos = Instr(ln, "[")
							
							ekzpos = Instr(ln, "]")
						
							arr:Array = New Array
							
							arr.name = Replace(Mid(ln, lzpos+1, ekapos-lzpos-1), " ", "")
							
							arr.typ = Typ_Float
							
							p1 = Int(Mid(ln, ekapos+1, ekzpos-ekapos-1))
							
							arr.FArray = New Float[p1]
							
							arr.amount = p1
							
							Self.Arrays.AddLast(arr)
						
						Else
						
							fv:FVar = New FVar
							
							fv.name = Replace(Mid(ln, leerpos+1, gzpos-leerpos-1), " ", "")
							
							val = Trim(Right(ln, Len(ln)-gzpos))
							
							'Local stellen:Int = Instr(val, ".")-Instr(val, "0")-1
						
							fv.value = Float(Self.Calc2(val))
								
							Self.FVars.AddLast(fv)
							
						EndIf
						
					Case "string"
											
						gzpos = Instr(ln$, Chr(34))
						
						lzpos = Instr(ln, " ", leerpos+1)
						
						If Lower(Mid(ln, leerpos+1, lzpos-leerpos-1)) = "dim" 'Array?
						
							ekapos = Instr(ln, "[")
							
							ekzpos = Instr(ln, "]")
						
							arr:Array = New Array
							
							arr.name = Replace(Mid(ln, lzpos+1, ekapos-lzpos-1), " ", "")
							
							arr.typ = Typ_String
														
							p1 = Int(Mid(ln, ekapos+1, ekzpos-ekapos-1))
							
							arr.SArray = New String[p1]
							
							arr.amount = p1
							
							Self.Arrays.AddLast(arr)
						
						Else

							
							sv:SVar = New SVar
							
							sv.name = Mid(ln, leerpos+1, gzpos-leerpos-1)
							
							sv.name = Replace(sv.name, " ", "")
							
							sv.name = Replace(sv.name, "=", "")
							
							val = Right(ln, Len(ln)-gzpos)
							
							sv.value = val
							
							Self.SVars.AddLast(sv)
						
						EndIf
						
					Case "if"
					
						Local lside:String, rside:String, lsideu:String, rsideu:String
							
						Local gpos:Int, kapos:Int, gapos:Int, ugpos:Int
						
						gpos = Instr(ln, "=")
						
						kapos = Instr(ln, "<")
						
						gapos = Instr(ln, ">")
						
						ugpos = Instr(ln, "!")
							
						If gpos <> 0
							
							lside = Self.Calc2(Mid(ln, lpos+1, gpos-lpos-1))
							rside = Self.Calc2(Mid(ln, gpos+1, Len(ln)-gpos))
								
							If Int(lside) <> Int(rside)
									
								ifc = ifc + 1
									
							EndIf
						
						ElseIf kapos <> 0
							
							lside = Self.Calc2(Mid(ln, lpos+1, kapos-lpos-1))
							rside = Self.Calc2(Mid(ln, kapos+1, Len(ln)-kapos))
								
							If Int(lside) > Int(rside)
									
								ifc = ifc + 1
									
							EndIf
							
						ElseIf gapos <> 0
							
							lside = Self.Calc2(Mid(ln, lpos+1, gapos-lpos-1))
							rside = Self.Calc2(Mid(ln, gapos+1, Len(ln)-gapos))
							
							If Int(lside) < Int(rside)
									
								ifc = ifc + 1
									
							EndIf
														
						ElseIf ugpos <> 0
							
							lside = Self.Calc2(Mid(ln, lpos+1, ugpos-lpos-1))
							rside = Self.Calc2(Mid(ln, ugpos+1, Len(ln)-ugpos))
								
							If Int(lside) = Int(rside)
									
								ifc = ifc + 1
									
							EndIf
							
						EndIf
						
					Case "goto"
						
						Local label:String
						
						label = Trim(Right(ln, Len(ln)-lpos))
											
						For go = EachIn Self.TGotos
						
							If go.name = label
							
								i = go.line
								
							EndIf
						
						Next
					
					Case "apptitle"
					
						p3 = Self.Calc2(Right(ln, Len(ln)-lpos)) 
						
						p3 = Replace(p3, Chr(34), "") 'Anfhrungszeichen entfernen
						
						AppTitle = "NSTC - "+p3
									
					Case "window"
															
						width = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))
						
						height = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))
						
						Graphics width, height
						
					Case "error"
					
						RuntimeError("Unknown error")
				
					Case "color"
					
						cr = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))
						
						cg = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))
						
						cb = Int(Self.Calc2(Mid(ln$,k2pos+1,Len(ln$)-k2pos)))
						
						SetColor cr, cg, cb

					
					Case "print"
					
						pstr = Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2))
						
						pstr = Replace(pstr, Chr(34), "") 'Anfhrungszeichen entfernen
						
						xpos = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))
											
						ypos = Int(Self.Calc2(Mid(ln$,k2pos+1,Len(ln$)-k2pos)))	
						
						DrawText pstr,xpos,ypos
		
		
					Case "input" 'Nicht sinnvoll benutzbar
									
						pstr = Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2))
						
						pstr = Replace(pstr, Chr(34), "") 'Anfhrungszeichen entfernen
						
						xpos = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))
											
						ypos = Int(Self.Calc2(Mid(ln$,k2pos+1,Len(ln$)-k2pos)))	
						
						Self.SVars.Remove(Input_Text)
						
						Input_Text.value = GInput(xpos,ypos,pstr)
						
						Input_Text.value = Chr(34)+Input_Text.value+Chr(34)
						
						Self.SVars.AddLast(Input_Text)  
				
					
					Case "rect"
						
						xpos = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))
						
						ypos = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))

						width = Int(Self.Calc2(Mid(ln$,k2pos+1,k3pos-k2pos-1)))
						
						height = Int(Self.Calc2(Mid(ln$,k3pos+1,Len(ln$)-k3pos)))
						
						DrawRect xpos, ypos, width, height
						
						
					Case "oval"
				
						xpos = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))

						ypos = Int(Self.Calc2( Mid(ln$,k1pos+1,k2pos-k1pos-1)))
						
						width = Int(Self.Calc2(Mid(ln$,k2pos+1,k3pos-k2pos-1)))

						height = Int(Self.Calc2(Mid(ln$,k3pos+1,Len(ln$)-k3pos)))
	
						DrawOval xpos, ypos, width, height
						
						
					Case "line"
											
						xpos = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))

						ypos = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))
						
						width = Int(Self.Calc2(Mid(ln$,k2pos+1,k3pos-k2pos-1)))
									
						height = Int(Self.Calc2(Mid(ln$,k3pos+1,Len(ln$)-k3pos)))
	
						DrawLine xpos, ypos, width, height
						
						
					Case "plot"

						xpos = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))

						ypos = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))

						Plot xpos, ypos
						
					Case "cls"
					
						Cls
					
					Case "clscolor"

						cr = Int(Self.Calc2(Mid(ln$,lpos+1,k1pos-Len(cmd)-2)))

						cg = Int(Self.Calc2(Mid(ln$,k1pos+1,k2pos-k1pos-1)))
						
						cb = Int(Self.Calc2(Mid(ln$,k2pos+1,Len(ln$)-k2pos)))
						
						SetClsColor cr, cg, cb
						
					Case "flip"
					
						Flip
					
					Case "waitkey"
					
						WaitKey
																
					Case "end"
					
						eop=1

					Case ""
					
					
					Default
					
						For iv = EachIn Self.IVars
							
							If Lower(Left(ln, Len(iv.name))) = Lower(iv.name)
						
								gzpos = Instr(ln, "=")
								
								If gzpos <> 0
									
									val = Right(ln, Len(ln)-gzpos-1)
																		
									iv.value = Int(Self.Calc2(val))
																		
									cmdv = 1
														
								EndIf
							
							EndIf
							
						Next
						
						For fv = EachIn Self.FVars
							
							If Lower(Left(ln, Len(fv.name))) = Lower(fv.name)
						
								gzpos = Instr(ln, "=")
								
								If gzpos <> 0
								
									val = Right(ln, Len(ln)-gzpos-1)
									
									fv.value = Int(Self.Calc2(val))
									
									cmdv = 1
									
								EndIf
							
							EndIf
							
						Next
						
						For sv = EachIn Self.SVars
							
							If Lower(Left(ln, Len(sv.name))) = Lower(sv.name)
						
								gzpos = Instr(ln, Chr(34))
								
								If gzpos <> 0
								
									val =  Right(ln, Len(ln)-gzpos+1)
														
									sv.value = val
									
									cmdv = 1
									
								EndIf
							
							EndIf
							
						Next
						
						For arr = EachIn Self.Arrays
							
							If Lower(Left(ln, Len(arr.name))) = Lower(arr.name)
							
								ekapos = Instr(ln, "[")
								
								ekzpos = Instr(ln, "]")
						
								gzpos = Instr(ln, "=")
								
								p1 = Int(Self.Calc2(Mid(ln, ekapos+1, ekzpos-ekapos-1)))
								
								If p1 < 0 Or p1 > arr.amount-1
								
								Print "Auf das Feld "+p1+" im Array <"+arr.name+"> kann nicht zugegriffen werden!"
								
								cmdv = 1

								Else
								
								If gzpos <> 0
								
									Select arr.typ
									
										Case Typ_Int
								
											val = Right(ln, Len(ln)-gzpos-1)
									
											arr.IArray[p1] = Int(Self.Calc2(val))
											
										Case Typ_Float
										
											val = Right(ln, Len(ln)-gzpos-1)
									
											arr.FArray[p1] = Float(Self.Calc2(val))
											
										Case Typ_String
											
											gzpos = Instr(ln, Chr(34))
											
											val = Right(ln, Len(ln)-gzpos+1)
									
											arr.SArray[p1] = val
											
										Default
										
											Print "Falscher Array-Typ"
											
											WaitKey
																				
										End Select

									cmdv = 1
									
								EndIf
									
								EndIf
							
							EndIf
							
						Next
						
						
						If Left(ln,1) = "#" cmdv = 1
												
						If cmdv = 0 
						
						Print "Scriptfehler in Zeile "+i+": Befehl <"+cmd$+"> nicht vorhanden."
						
						WaitKey
						
						EndIf
						
					End Select
					
									
			
			EndIf
			
			If eop Exit 'Falls die EndOfProgramm-Variable 1 ist, wird die Schleife verlassen
			
			cmdv = 0
			
			Next
			
		Print "Script erfolgreich ausgefuehrt!"
		
	EndMethod
		
	Method Calc2:String(str:String) 'Methode zum Ausrechnen von Strings mit Scriptvariablen

		Local iv:IVar, fv:FVar, sv:SVar, arr:Array 'Die Variablen-Types
		
		Local p1:Int, ekapos:Int, ekzpos:Int, p2:String
				
		If Instr(str, Chr(34)) = 0 'Prfen ob der String ein Script-String ist
		
			For iv = EachIn Self.IVars 'Alle Int-Variablen abfragen
					
				str = Replace(str, iv.name, iv.value) 'Name der Variable durch Wert ersetzen
		
			Next
				
			For fv = EachIn Self.FVars 'Alle Float Variablen abfragen
					
				str = Replace(str, fv.name, fv.value) 'Name der Variable durch Wert ersetzen
				
			Next
				
			For sv = EachIn Self.SVars 'Alle String-Variablen abfragen
			
				str = Replace(str, sv.name, sv.value) 'Name der Variable durch Wert ersetzen
					
			Next
			
			
			ekapos = Instr(str, "[")
			
			ekzpos = Instr(str, "]")
			
			If ekapos > 0
			
			p2 = Mid(str, ekapos+1, ekzpos-ekapos-1)
			
			p1 = Int(Self.Calc2(p2))
			
			For arr = EachIn Self.Arrays
			
				If p1 < 0 Or p1 > arr.amount-1
			
				Print "Auf das Feld "+p1+" im Array <"+arr.name+"> kann nicht zugegriffen werden!"
				
				Else
			
				Select arr.typ
				
					Case Typ_Int
				
						str = Replace(str, arr.name+"["+p2+"]", arr.IArray[p1])
						
					Case Typ_Float
					
						str = Replace(str, arr.name+"["+p2+"]", arr.FArray[p1])
					
					Case Typ_String
					
						str = Replace(str, arr.name+"["+p2+"]", arr.SArray[p1])
					
				End Select
				
				EndIf
			
			Next
			
			EndIf

			If Instr(str, Chr(34)) = 0
				
				Local khpos:Int = Instr(Lower(str),"keyhit(")
					
				If khpos > 0							
						
					str = Replace(Lower(str), Lower(Mid(str,khpos,Instr(str,")")-khpos+1)) , KeyHit(Int(Mid(str, khpos+7, khpos+7-Instr(str,")")))))
						
				EndIf
					
				Local kdpos:Int = Instr(Lower(str),"keydown(")
					
				If kdpos > 0
						
					str = Replace(Lower(str), Lower(Mid(str,kdpos,Instr(str,")")-kdpos+1)) , KeyDown(Int(Mid(str, kdpos+8, kdpos+8-Instr(str,")")))))
							
				EndIf
					
				Local rndpos:Int = Instr(Lower(str),"rand(")
					
				If rndpos > 0
					
					str =  Replace(Lower(str), Lower(Mid(str,rndpos,Instr(str,")")-rndpos+1)) , Rand(Int(Mid(str, rndpos+5, rndpos+5-Instr(str,")")))))
						
				EndIf
				
				Local sinpos:Int = Instr(Lower(str),"sin(")
				
				If sinpos > 0
					
					str =  Replace(Lower(str), Lower(Mid(str,sinpos,Instr(str,")")-sinpos+1)) , Sin(Int(Self.Calc2(Mid(str, sinpos+4, sinpos+4-Instr(str,")"))))))
						
				EndIf
				
				Local cospos:Int = Instr(Lower(str),"cos(")
				
				If cospos > 0
					
					str =  Replace(Lower(str), Lower(Mid(str,cospos,Instr(str,")")-cospos+1)) , Sin(Int(Self.Calc2(Mid(str, cospos+4, cospos+4-Instr(str,")"))))))
						
				EndIf
					
				str = Calc(Str)	 'Falls nicht wird der Wert ausgerechnet
				
			EndIf
			
		EndIf
		
			
		Return str 'Ergebnis zurckgeben

	EndMethod
	
End Type



'Funktionen

Function Calc:String(term:String) 'Funktion zum Ausrechnen von Strings
	
	term = Trim(term)  'Term "subern"
	
	term = Lower(term)
	
	term = Replace(term, "pi", Pi)
		
	If (Instr(term,"+")+Instr(term,"-")+Instr(term,"*")+Instr(term,"/")+Instr(term,"^")) = 0 Return term 'berprfung ob berhaupt ein Operand vorhanden ist
	
	term = CalcPow(term)		
	
	term = CalcPoint(term)
		
	term = CalcLine(term)
	 
	Return Int(term)	

End Function

Function CalcLine:String(term:String)

	Local result:Int 'Ergebnis der Rechnung
	
	Local z1:Int, z2:Int 'Die zwei Zahlen, mit denen die Rechnung durchgefhrt wird
	
	Local ppos:Int, spos:Int 'Positionen der jeweils ersten Operanden von hinten (Mal, Geteilt)
		
	Local term2:String, term3:String 'Zweiter Term falls noch Operand vorhanden
	
	term = Trim(term)  'Term "subern"
	
	If (Instr(term,"+")+Instr(term,"-")) = 0 Return term 'berprfung ob berhaupt ein Operand vorhanden ist
	
	ppos = RInstr(term, "+")
	
	spos = RInstr(term, "-")
	
     If ppos>spos'berprfen ob der hinterste Operand ein + ist
	
		term2 = Left(term, RInstr(term,"+")-1) 'Linke Seite des Operanden
		
		If (RInstr(term2,"+")+RInstr(term2,"-")) > 0 term2 = CalcLine(term2)
						
		z1 = term2.ToInt() 'Erste Zahl zum Rechnen
		z2 = Int(Right(term, Len(term)-RInstr(term,"+"))) 'Zweite Zahl zum Rechnen (Rechte Seite des Operanden)
		
		result = z1+z2
		
		'term = Replace(term,z1+"+"+z2,result)
	
	Else 'berprfen ob der hinterste Operand ein - ist
	
	
		term2 = Left(term, RInstr(term,"-")-1) 'Linke Seite des Operanden
		
		If (RInstr(term2,"+")+RInstr(term2,"-")) > 0 term2 = CalcLine(term2)
		
		z1 = term2.ToInt() 'Erste Zahl zum Rechnen
		z2 = Int(Right(term, Len(term)-RInstr(term,"-"))) 'Zweite Zahl zum Rechnen (Rechte Seite des Operanden)
		
		result = z1-z2
				
		'term = Replace(term,z1+"-"+z2,result)
	
	
	EndIf	
	
	Return result


EndFunction

Function CalcPoint:String(term:String)

	Local result:Int 'Ergebnis der Rechnung
	
	Local z1:Int, z2:Int 'Die zwei Zahlen, mit denen die Rechnung durchgefhrt wird
	
	Local mpos:Int, dpos:Int, opos:Int 'Positionen der jeweils ersten Operanden von hinten (Mal, Geteilt)
		
	Local term2:String, term3:String, term2v:String 'Zweiter Term falls noch Operand vorhanden
	
	term = Trim(term)  'Term "subern"
	
	If (Instr(term,"*")+Instr(term,"/")) = 0 Return term 'berprfung ob berhaupt ein Operand vorhanden ist
	
	mpos = RInstr(term, "*")
	
	dpos = RInstr(term, "/")

      If mpos>dpos'berprfen ob der hinterste Operand ein * ist
			
		term2 = Left(term, mpos-1) 'Mid(term, opos+1, mpos) 'Linke Seite des Operanden
		
		term2v = term2
				
		If (RInstr(term2,"*")+RInstr(term2,"/")) <> 0 term2 = CalcPoint(term2)
		
		term = Replace(term, term2v, term2)
				
		opos = NextOp(term2, True)
						
		term2 = Mid(term2, opos+1, mpos)
		
		opos = NextOp(term, False, mpos+1)
				
		term3 = Mid(term, RInstr(term, "*")+1, opos-RInstr(term,"*")-1)
		
		z1 = Int(term2)
		z2 = Int(term3)
		result = z1*z2
		
		term = Replace(term,z1+"*"+z2,result)
	
	Else 'berprfen ob der hinterste Operand ein / ist
	
		term2 = Left(term, dpos-1) 'M'Linke Seite des Operanden
		
		term2v = term2
				
		If (RInstr(term2,"*")+RInstr(term2,"/")) <> 0 term2 = CalcPoint(term2)
		
		term = Replace(term, term2v, term2)
				
		opos = NextOp(term2, True)
						
		term2 = Mid(term2, opos+1, dpos)
		
		opos = NextOp(term, False, dpos+1)
				
		term3 = Mid(term, RInstr(term, "/")+1, opos-RInstr(term,"/")-1)
		
		z1 = Int(term2)
		z2 = Int(term3)
		result = z1/z2
		
		term = Replace(term,z1+"/"+z2,result)
	
	
	EndIf	
	
	Return term

EndFunction

Function CalcPow:String(term:String)

	Local result:Int 'Ergebnis der Rechnung
	
	Local z1:Int, z2:Int 'Die zwei Zahlen, mit denen die Rechnung durchgefhrt wird
	
	Local ppos:Int, opos:Int 'Position des ersten Operanden von hinten (Potenz)
		
	Local term2:String, term3:String, term2v:String 'Zweiter Term falls noch Operand vorhanden
	
	term = Trim(term)  'Term "subern"
	
	If Instr(term,"^") = 0 Return term 'berprfung ob berhaupt ein Operand vorhanden ist
	
	ppos = RInstr(term, "^")

	term2 = Left(term, ppos-1)  'Linke Seite des Operanden
		
	term2v = term2
				
	If RInstr(term2,"^") <> 0 term2 = CalcPoint(term2)
		
	term = Replace(term, term2v, term2)
				
	opos = NextOp(term2, True)
						
	term2 = Mid(term2, opos+1, ppos)
		
	opos = NextOp(term, False, ppos+1)
				
	term3 = Mid(term, RInstr(term, "^")+1, opos-RInstr(term,"^")-1)
		
	z1 = Int(term2)
	z2 = Int(term3)
	result = z1^z2
		
	term = Replace(term,z1+"^"+z2,result)
	
	Return term

EndFunction

Function ScriptLines:Int(file:String)
	
	Local ifile:TStream = ReadStream(file)
		
	Local zaehler:Int
		
	While Not Eof(ifile)
		
		ReadLine(ifile)
			
		zaehler = zaehler + 1
		
	Wend
	
	Return zaehler
	
EndFunction

Function NextOp:Int(str:String, backw:Int = 0, pos:Int = 1)

	Local nop:Int
	
	If backw = True
	
		nop = RInstr(str,"+",pos)
		
		If RInstr(str, "-", pos) > nop nop = RInstr(str, "-", pos)
		
		If RInstr(str, "*", pos) > nop nop = RInstr(str, "*", pos)
		
		If RInstr(str, "/", pos) > nop nop = RInstr(str, "/", pos)
		
		If RInstr(str, "^", pos) > nop nop = RInstr(str, "^", pos)
	
	Else
	
		nop = Instr(str,"+",pos)
		
		If Instr(str, "-", pos) > nop nop = Instr(str, "-", pos)
		
		If Instr(str, "*", pos) > nop nop = Instr(str, "*", pos)
		
		If Instr(str, "/", pos) > nop nop = Instr(str, "/", pos)
		
		If Instr(str, "^", pos) > nop nop = Instr(str, "^", pos)
		
	EndIf

	Return nop

EndFunction


Function RInstr:Int(str:String,s:String,c:Int=0) '

	Local i:Int
	
	If Len(s) = 0 Then Return 0
	
	For i = Len(str$)-c To 1 Step -1
	
		If Mid(str$,i,Len(s)) = s Then
		
			Return i
		
		EndIf
	
	Next
	
	Return 0
	
EndFunction


Function GInput:String(x:Int,y:Int,prompt:String)

	FlushKeys
	
	Local char:Int = GetChar()
	Local inp:String
	
	Repeat
	
		char = GetChar()
	
		If KeyHit(KEY_BACKSPACE) inp = Left(inp, Len(inp)-1)
		
		If char>32 And char<127
		
			inp = inp + Chr(char)
		
		EndIf
		
		DrawText prompt, x, y
		
		DrawText inp, x+TextWidth(prompt)+5,y 
		
		If AppTerminate() Or KeyHit(KEY_ESCAPE) End
				
		Flip
	
		Cls
		
	Until KeyHit(KEY_ENTER)
	
	Return inp
	
EndFunction