

;bcc 
;Binr asm

Global Register$[4] 

Const rA=0
Const rB=1
Const rC=2
Const rD=3

;variablentyp
Const v_int=0
Const v_float=1
Const v_string=2

;befehle

Const b_int$="00000000"
Const b_add_i$="00000001"
Const b_sub_i$="00000010"
Const b_mul_i$="00000011"
Const b_div_i$="00000100"
Const b_mov_WR$="00000101"
Const b_mov_VR$="00000110"
Const b_mov_RR$="00000111"
Const b_exc$="00001000"
Const b_set$="00001001"
Const b_jne$="00001010"
Const b_jeq$="00001011"
Const b_jhi$="00001100"
Const b_jlo$="00001101"
Const b_lbl$="00001110"
Const b_var_i$="00001111"
Const b_var_f$="00010000"
Const b_var_s$="00010001"
Const b_fre$="00010010"
Const b_add_f$="00010011"
Const b_add_s$="00010100"
Const b_sub_f$="00010101"
Const b_mul_f$="00010111"
Const b_div_f$="00011001"
Const b_rnd$="00010110"


;interrupts

Const i_end$="00000000"
Const i_wai$="00000001"
Const i_pri$="00000010"
Const i_gra$="00000011"
Const i_cls$="00000100"
Const i_lin$="00000101"
Const i_rec$="00000110"
Const i_ovl$="00000111"
Const i_clo$="00001000"
Const i_app$="00001001"
Const i_txt$="00001010"
Const i_flp$="00001011"


Type sprungmarken
	Field index
	Field pos
	
End Type 
Global Spr.sprungmarken

Type variablen
	Field index
	
	Field typ;0=int 1=float 2=string
	
	Field v_int%
	Field v_float#
	Field v_string
End Type
Global var.variablen


Global scriptlaenge
Dim Script$(1,3)

Local in$=Replace(CommandLine(),Chr(34),"")

script_load(in$)
script_pre_run
script_run

RuntimeError "unerwartetes scriptende"

End

Function debug(c)
	
	DebugLog "*****************************"
	DebugLog "abbild:"
	DebugLog "R a: "+Register[rA]
	DebugLog "R b: "+Register[rB]
	DebugLog "R c: "+Register[rC]
	DebugLog "R d: "+Register[rD]
	DebugLog ""
	DebugLog "befehl: "+Script(c,0)
	DebugLog "wert 1: "+Script(c,1)
	DebugLog "wert 2: "+Script(c,2)
	
	
	
End Function


Function script_load(in$)
	
	Local datei=ReadFile(in$)
	Local cc
	
	scriptlaenge=ReadLine(datei)
	Dim Script$(scriptlaenge,3)
	
	
	For cc=0 To scriptlaenge-1
		
		Local zz$=ReadLine(datei)
		
		p1=Instr(zz,";")
		
		If p1>0
			zz=(Left(zz,Len(zz)-(Len(zz)-p1+1)))
		EndIf
		
		Script$(cc,2)=Trim(zz)
		
	Next
	
	CloseFile datei
	
End Function

Function script_pre_run()
	
	Local c
	Local varcount
	
	For c=0 To scriptlaenge-1
		
		If Len(Script(c,2))>8
			
			Script(c,0)=Left(Script(c,2),8)
			
			Script(c,2)=Trim(Right(Script(c,2),(Len(Script(c,2))-8)))
			
			If Len(Script(c,2))>8
				
				Script(c,1)=Left(Script(c,2),8)
				Script(c,2)=Right(Script(c,2),8)
				
				
				
			Else
				
				Script(c,1)=Script(c,2)
				Script(c,2)=""
				
			EndIf
			
		Else
			
			Script(c,0)=Script(c,2)
			Script(c,1)=""
			Script(c,2)=""
			
		EndIf
		
	Next
	
	
	For c=0 To scriptlaenge-1
		If Script(c,0)="00001110";SPRUNGMARKE
			
			
			Spr.sprungmarken=New sprungmarken
			
			Spr\index=BintoInt(Script(c,1))
			
			
			Spr\pos=c
			
		EndIf
		
		
	Next
	
	
End Function




Function script_run()
	Local count
	For count=0 To scriptlaenge-1
		
		Local befehl$=Script(count,0)
		
		Select befehl
				
			Case b_int:f_int(count)                                        ;interrupt
			
				
			Case b_add_i                                              ;addieren (int)
				Register[rA]=Int(Register[rA])+Int(Register[rB])
			Case b_add_f                                              ;addieren (float)
				Register[rA]=Float(Register[rA])+Float(Register[rB])
			Case b_add_s                                              ;addieren string)
				Register[rA]=Register[rA]+Register[rB]
			Case b_sub_i                                              ;subtrahieren (int)
				Register[rA]=Int(Register[rA])-Int(Register[rB])
			Case b_sub_f                                              ;subtrahieren (float)
				Register[rA]=Float(Register[rA])-Float(Register[rB])
			Case b_mul_i                                              ;multiplizieren (int)
				Register[rA]=Int(Register[rA])*Int(Register[rB])
			Case b_mul_f                                              ;multiplizieren (float)
				Register[rA]=Float(Register[rA])*Float(Register[rB])
			Case b_div_i                                              ;dividieren (int)
				Register[rA]=Int(Register[rA])/Int(Register[rB])
			Case b_div_f                                              ;dividieren (float)
				Register[rA]=Float(Register[rA])/Float(Register[rB])
			Case b_mov_WR                                             ;hole wert in register
				Register[BintoInt(Script(count,2))-1]=BintoInt(Script(count,1))
				
			Case b_mov_VR:f_mov_VR(count)                             ;hole variable in register
			
			Case b_mov_RR                                             ;hole Register in Register
				Register[BintoInt(Script(count,2))-1]=Register[BintoInt(Script(count,1))-1]
				
			Case b_exc:f_exc(count)                                   ;tauschen
			Case b_set:f_set(count)                                   ;setzen
			Case b_jne:f_jne(count)                                   ;jump nicht gleich
			Case b_jeq:f_jeq(count)                                   ;jump gleich
			Case b_jhi:f_jhi(count)                                   ;jump wenn a hher b
			Case b_jlo:f_jlo(count)                                   ;jump wenn a kleiner b
			
			Case b_lbl                                                ;label
				
			Case b_var_i:f_var_i(count)                               ;int variable
			Case b_var_f:f_var_f(count)                               ;float variable
			Case b_var_s:f_var_s(count)                               ;string variable
			Case b_fre: f_fre(count)                                  ;variable lschen
				
			Case b_rnd                                                ;zufallszahl in register
				Register[rA]=Rnd(BintoInt(Script(count,1)),BintoInt(Script(count,2)))
				
		End Select
		
		
	Next
	
End Function




Function f_int(count)
	Local interrupt$=Script(count,1)
	Select interrupt
		Case i_end
			End
		Case i_wai
			WaitKey()
		Case i_pri
			Print Register[rD]
		Case i_gra
			Graphics Register[rA],Register[rB],Register[rC],2
			SetBuffer BackBuffer()
		Case i_cls
			Cls
		Case i_clo
			Color Register[rA],Register[rB],Register[rC]
		Case i_lin
			Line Register[rA],Register[rB],Register[rC],Register[rD]
		Case i_rec
			Rect Register[rA],Register[rB],Register[rC],Register[rD],BintoInt(Script(count,2))
		Case i_ovl
			Oval Register[rA],Register[rB],Register[rC],Register[rD],BintoInt(Script(count,2))
		Case i_app
			AppTitle Register[rA]
		Case i_txt
			Text Register[rA],Register[rB],Register[rD],Register[rC]
		Case i_flp
			Flip
			
			
	End Select
End Function

Function f_mov_VR(count)
	var_i=BintoInt(Script(count,1))
	reg=BintoInt(Script(count,2))-1
	For var.variablen=Each variablen
		If var\index=var_i
			Select var\typ
				Case v_int
					Register[reg]=var\v_int
				Case v_float
					Register[reg]=var\v_float
				Case v_string
					Register[reg]=var\v_string
			End Select
		EndIf
	Next
End Function

Function f_exc(count)
	tmp$=Register[BintoInt(Script(count,2))-1]
	Register[BintoInt(Script(count,2))-1]=Register[BintoInt(Script(count,1))-1]
	Register[BintoInt(Script(count,1))-1]=tmp
End Function

Function f_set(count)
	Local done
	For var.variablen=Each variablen
		If BintoInt(Script(count,1))=var\index
			Select var\typ
				Case v_int
					var\v_int=Register[BintoInt(Script(count,2))-1]
					done=1
				Case v_float
					var\v_float=Register[BintoInt(Script(count,2))-1]
					done=1
				Case v_string
					var\v_string=Register[BintoInt(Script(count,2))-1]
					done=1
			End Select
		EndIf
	Next
	If done=0 Then RuntimeError "cant set variable"
End Function

Function f_jne(count)
	If Register[rA]<>Register[rB]
		For Spr.sprungmarken=Each sprungmarken
			If BintoInt(Script(count,1))=Spr\index
				count=Spr\pos
			EndIf
		Next
	EndIf
End Function

Function f_jeq(count)
	If Register[rA]=Register[rB]
		For Spr.sprungmarken=Each sprungmarken
			If Register[rC]=Spr\index
				count=Spr\pos
			EndIf
		Next
	EndIf
End Function

Function f_jhi(count)
	If Register[rA]>Register[rB]
		For Spr.sprungmarken=Each sprungmarken
			If Register[rC]=Spr\index
				count=Spr\pos
			EndIf
		Next
	EndIf
End Function

Function f_jlo(count)
	If Register[rA]<Register[rB]
		For Spr.sprungmarken=Each sprungmarken
			If Register[rC]=Spr\index
				count=Spr\pos
			EndIf
		Next
	EndIf
End Function

Function f_var_i(count)
	var.variablen=New variablen
	var\index=BintoInt(Script(count,1))
	var\v_int=v_int
	var\v_int=BintoInt(Script(count,2))
End Function

Function f_var_f(count)
	var.variablen=New variablen
	var\index=BintoInt(Script(count,1))
	var\typ=v_float
	var\v_float=BintoInt(Script(count,2))
End Function

Function f_var_s(count)
	var.variablen=New variablen
	var\index=BintoInt(Script(count,1))
	var\typ=v_string
	var\v_int=BintoInt(Script(count,2))
End Function

Function f_fre(count)
	Local done
	For var.variablen=Each variablen
		If var\index=BintoInt(Script(count,1))
			Delete var
			done=1
		EndIf
	Next
	If done=0 Then RuntimeError "cant delete variable, cause it not exists"
End Function












Function BintoInt(in$)
	
	Local L=Len(in$)
	Local out
	Local i
	
	For i=1 To L
		If Mid$(in,i,1)= "1"
			out=out+2^(L-i)
		EndIf
		
	Next
	
	Return out
	

End Function
















;~IDEal Editor Parameters:
;~F#5E#70#8B#107#128#139#13F#153#15D#167#171#17B#182#189#190#1A6
;~C#Blitz3D